ideal
INCLUDE	"z80const.asi"
INCLUDE	"z-80m.asi"
;
segment	z_80	common
	assume	cs:z_80
extrn	WRT8:near
extrn	WRT16:near
extrn	INP:near
extrn	OUTP:near
ends
segment	zx_emul
extrn	promap:word
extrn	primap:word
ends
segment	z_80	common
extrn	@o254a:near
extrn	@emr0:near
COD=PREF_DD
; nop 
	null
; ld bc,nn 
	ldnn	bc
; ld (bc),a 
	ldmr	bc
; inc bc 
	unaf	inc bc
; inc b 
	del1	inc b
; dec b 
	del1	dec b
; ld b,n 
	ldn	b
; rlca 
	roll	rol a
; ex af,af' 
	exaf
; add ix,bc 
	add16	ix bc
; ld a,(bc) 
	ldrm	bc
; dec bc 
	unaf	dec bc
; inc c 
	del1	inc c
; dec c 
	del1	dec c
; ld c,n 
	ldn	c
; rrca 
	roll	ror a
;
CHECK	1070h
; djnz n 
	djnz
; ld de,nn 
	ldnn	de
; ld (de),a 
	ldmr	de
; inc de 
	unaf	inc de
; inc d 
	del1	inc d
; dec d 
	del1	dec d
; ld d,n 
	ldn	d
; rla 
	roll	rcl a
; jr n 
	jmr
; add ix,de 
	add16	ix de
; ld a,(de) 
	ldrm	de
; dec de 
	unaf	dec de
; inc e 
	del1	inc e
; dec e 
	del1	dec e
; ld e,n 
	ldn	e
; rra 
	roll	rcr a
;
CHECK	2070h
; jr nz,n 
	jmr	z
; ld ix,nn 
	ldnn	ix
; ld (nn),ix 
	ldnnr	ix
; inc ix 
	unaf	inc ix
; inc hx 
	del1	inc hx
; dec hx 
	del1	dec hx
; ld hx,n 
	ldn	hx
; daa 
	una	daa
; jr z,n 
	jmr	nz
; add ix,ix 
	add16	ix ix
; ld ix,(nn) 
	ldrnn	ix
; dec ix 
	unaf	dec ix
; inc lx 
	del1	inc lx
; dec lx 
	del1	dec lx
; ld lx,n 
	ldn	lx
; cpl 
	unaf	not a
;
CHECK	3070h
; jr nc,n 
	jmr	c
; ld sp,nn 
	ldnn	sp
; ld (nn),a 
	ldnr	a
; inc sp 
	unaf	inc sp
; inc (ix+d) 
	unax	ix inc
; dec (ix+d) 
	unax	ix dec
; ld (ix+d),n 
	ldx	ix m n
; scf 
	una	stc
; jr c,n 
	jmr	nc
; add ix,sp 
	add16	ix sp
; ld a,(nn) 
	ldrn	a
; dec sp 
	unaf	dec sp
; inc a 
	del1	inc a
; dec a 
	del1	dec a
; ld a,n 
	ldn	a
; ccf 
	una	cmc
;
CHECK	4070h
; ld r,s 
	irpc	r,bcde
	irp	s,b,c,d,e,hx,lx,m,a
	ldx	ix r s
	endm
	endm
	irpc	r,hl
	irp	s,b,c,d,e,hx,lx
	ldx	ix r&x s
	endm
	ldx	ix r m
	ldx	ix r&x a
	endm
	irpc	s,bcdehlma
	ldx	ix m s
	endm
	irp	s,b,c,d,e,hx,lx,m,a
	ldx	ix a s
	endm
;
CHECK	8070h
; cmd8 r 
	irp	cm,add,adc
	irp	r,b,c,d,e,hx,lx,m,a
	a8x	ix cm r a
	endm
	endm
	irp	cm,sub,sbb
	irp	r,b,c,d,e,hx,lx,m,a
	a8x	ix cm r s
	endm
	endm
	irp	cm,and,xor,or,cmp
	irp	r,b,c,d,e,hx,lx,m,a
	a8x	ix cm r
	endm
	endm
;
CHECK	0C070h
; ret nz 
	retu	z
; pop bc 
	pop16	bc
; jp nz,nn 
	jup	z
; jp nn 
	jup
; call nz,nn 
	cal	z
; push bc 
	push16	bc
; add a,n 
	a8	add n a
; rst 0 
	dbl	1
; ret z 
	retu	nz
; ret 
	retu
; jp z,nn 
	jup	nz
; #CB 
	cxpref	ix PREF_DD_CB
; call z,nn 
	cal	nz
; call nn 
	cal
; adc a,n 
	a8	adc n a
; rst 8 
	rst	8
;
CHECK	0D070h
; ret nc 
	retu	c
; pop de 
	pop16	de
; jp nc,nn 
	jup	c
; out (n),a 
	out8
; call nc,nn 
	cal	c
; push de 
	push16	de
; sub n 
	a8	sub n s
; rst 16 
	rst	16
; ret c 
	retu	nc
; exx 
	dbl	1
; jp c,nn 
	jup	nc
; in a,(n) 
	in8
; call c,nn 
	cal	nc
; #DD 
	prefix	PREF_DD
; sbc a,n 
	a8	sbb n s
; rst 24 
	rst	24
;
CHECK	0E070h
; ret po 
	retu	p
; pop ix 
	pop16	ix
; jp po,nn 
	jup	p
; ex (sp),ix 
	exsp	ix
; call po,nn 
	cal	p
; push ix 
	push16	ix
; and n 
	a8	and n
; rst 32 
	rst	32
; ret pe 
	retu	np
; jp (ix) 
	jpc	ix
; jp pe,nn 
	jup	np
; ex de,hl 
	exdehl
; call pe,nn 
	cal	np
; #ED 
	prefix	PREF_ED
; xor n 
	a8	xor n
; rst 40 
	rst	40
;
CHECK	0F070h
; ret p 
	retu	s
; pop af 
	popaf
; jp p,nn 
	jup	s
; di 
	dint
; call p,nn 
	cal	s
; push af 
	pushaf
; or n 
	a8	or n
; rst 48 
	rst	48
; ret m 
	retu	ns
; ld sp,ix 
	ldsp	ix
; jp m,nn 
	jup	ns
; ei 
	eint
; call m,nn 
	cal	ns
; #FD 
	prefix	PREF_FD
; cp n 
	a8	cmp n
; rst 56 
	rst	56
;
CHECK	10070h
COD=PREF_DD_CB
; roll r 
	irp	cm,rol,ror,rcl,rcr,sal,sar,shl,shr
	irpc	r,bcdehlma
	rollx	cm r
	endm
	endm
;
CHECK	4084h
; bit b,r 
	IRPC	b,01234567
	IRPC	r,bcdehlma
	bitx	b r
	ENDM
	ENDM
;
CHECK	8084h
; res b,r 
	IRPC	b,01234567
	IRPC	r,bcdehlma
	resx	b r
	ENDM
	ENDM
;
CHECK	0C084h
; set b,r 
	IRPC	b,01234567
	IRPC	r,bcdehlma
	setx	b r
	ENDM
	ENDM
;
CHECK	10084h
ends
end