ideal
INCLUDE	"z80const.asi"
INCLUDE	"z-80m.asi"
;
segment	z_80	common
	assume	cs:z_80
extrn	WRT8:near
extrn	WRT16:near
extrn	INP:near
extrn	OUTP:near
ends
segment	zx_emul
extrn	promap:word
extrn	primap:word
ends
segment	z_80	common
extrn	@o254a:near
extrn	@emr0:near
COD=PREF_FD
; nop 
	null
; ld bc,nn 
	ldnn	bc
; ld (bc),a 
	ldmr	bc
; inc bc 
	unaf	inc bc
; inc b 
	del1	inc b
; dec b 
	del1	dec b
; ld b,n 
	ldn	b
; rlca 
	roll	rol a
; ex af,af' 
	exaf
; add iy,bc 
	add16	iy bc
; ld a,(bc) 
	ldrm	bc
; dec bc 
	unaf	dec bc
; inc c 
	del1	inc c
; dec c 
	del1	dec c
; ld c,n 
	ldn	c
; rrca 
	roll	ror a
;
CHECK	10B0h
; djnz n 
	djnz
; ld de,nn 
	ldnn	de
; ld (de),a 
	ldmr	de
; inc de 
	unaf	inc de
; inc d 
	del1	inc d
; dec d 
	del1	dec d
; ld d,n 
	ldn	d
; rla 
	roll	rcl a
; jr n 
	jmr
; add iy,de 
	add16	iy de
; ld a,(de) 
	ldrm	de
; dec de 
	unaf	dec de
; inc e 
	del1	inc e
; dec e 
	del1	dec e
; ld e,n 
	ldn	e
; rra 
	roll	rcr a
;
CHECK	20B0h
; jr nz,n 
	jmr	z
; ld iy,nn 
	ldnn	iy
; ld (nn),iy 
	ldnnr	iy
; inc iy 
	unaf	inc iy
; inc hy 
	del1	inc hy
; dec hy 
	del1	dec hy
; ld hy,n 
	ldn	hy
; daa 
	una	daa
; jr z,n 
	jmr	nz
; add iy,iy 
	add16	iy iy
; ld iy,(nn) 
	ldrnn	iy
; dec iy 
	unaf	dec iy
; inc ly 
	del1	inc ly
; dec ly 
	del1	dec ly
; ld ly,n 
	ldn	ly
; cpl 
	unaf	not a
;
CHECK	30B0h
; jr nc,n 
	jmr	c
; ld sp,nn 
	ldnn	sp
; ld (nn),a 
	ldnr	a
; inc sp 
	unaf	inc sp
; inc (iy+d) 
	unax	iy inc
; dec (iy+d) 
	unax	iy dec
; ld (iy+d),n 
	ldx	iy m n
; scf 
	una	stc
; jr c,n 
	jmr	nc
; add iy,sp 
	add16	iy sp
; ld a,(nn) 
	ldrn	a
; dec sp 
	unaf	dec sp
; inc a 
	del1	inc a
; dec a 
	del1	dec a
; ld a,n 
	ldn	a
; ccf 
	una	cmc
;
CHECK	40B0h
; ld r,s 
	irpc	r,bcde
	irp	s,b,c,d,e,hy,ly,m,a
	ldx	iy r s
	endm
	endm
	irpc	r,hl
	irp	s,b,c,d,e,hy,ly
	ldx	iy r&y s
	endm
	ldx	iy r m
	ldx	iy r&y a
	endm
	irpc	s,bcdehlma
	ldx	iy m s
	endm
	irp	s,b,c,d,e,hy,ly,m,a
	ldx	iy a s
	endm
;
CHECK	80B0h
; cmd8 r 
	irp	cm,add,adc
	irp	r,b,c,d,e,hy,ly,m,a
	a8x	iy cm r a
	endm
	endm
	irp	cm,sub,sbb
	irp	r,b,c,d,e,hy,ly,m,a
	a8x	iy cm r s
	endm
	endm
	irp	cm,and,xor,or,cmp
	irp	r,b,c,d,e,hy,ly,m,a
	a8x	iy cm r
	endm
	endm
;
CHECK	0C0B0h
; ret nz 
	retu	z
; pop bc 
	pop16	bc
; jp nz,nn 
	jup	z
; jp nn 
	jup
; call nz,nn 
	cal	z
; push bc 
	push16	bc
; add a,n 
	a8	add n a
; rst 0 
	dbl	1
; ret z 
	retu	nz
; ret 
	retu
; jp z,nn 
	jup	nz
; #CB 
	cxpref	iy PREF_FD_CB
; call z,nn 
	cal	nz
; call nn 
	cal
; adc a,n 
	a8	adc n a
; rst 8 
	rst	8
;
CHECK	0D0B0h
; ret nc 
	retu	c
; pop de 
	pop16	de
; jp nc,nn 
	jup	c
; out (n),a 
	out8
; call nc,nn 
	cal	c
; push de 
	push16	de
; sub n 
	a8	sub n s
; rst 16 
	rst	16
; ret c 
	retu	nc
; exx 
	dbl	1
; jp c,nn 
	jup	nc
; in a,(n) 
	in8
; call c,nn 
	cal	nc
; #DD 
	prefix	PREF_DD
; sbc a,n 
	a8	sbb n s
; rst 24 
	rst	24
;
CHECK	0E0B0h
; ret po 
	retu	p
; pop iy 
	pop16	iy
; jp po,nn 
	jup	p
; ex (sp),iy 
	exsp	iy
; call po,nn 
	cal	p
; push iy 
	push16	iy
; and n 
	a8	and n
; rst 32 
	rst	32
; ret pe 
	retu	np
; jp (iy) 
	jpc	iy
; jp pe,nn 
	jup	np
; ex de,hl 
	exdehl
; call pe,nn 
	cal	np
; #ED 
	prefix	PREF_ED
; xor n 
	a8	xor n
; rst 40 
	rst	40
;
CHECK	0F0B0h
; ret p 
	retu	s
; pop af 
	popaf
; jp p,nn 
	jup	s
; di 
	dint
; call p,nn 
	cal	s
; push af 
	pushaf
; or n 
	a8	or n
; rst 48 
	rst	48
; ret m 
	retu	ns
; ld sp,iy 
	ldsp	iy
; jp m,nn 
	jup	ns
; ei 
	eint
; call m,nn 
	cal	ns
; #FD 
	prefix	PREF_FD
; cp n 
	a8	cmp n
; rst 56 
	rst	56
;
CHECK	100B0h
COD=PREF_FD_CB
; roll r 
	irp	cm,rol,ror,rcl,rcr,sal,sar,shl,shr
	irpc	r,bcdehlma
	rollx	cm r
	endm
	endm
;
CHECK	40D0h
; bit b,r 
	IRPC	b,01234567
	IRPC	r,bcdehlma
	bitx	b r
	ENDM
	ENDM
;
CHECK	80D0h
; res b,r 
	IRPC	b,01234567
	IRPC	r,bcdehlma
	resx	b r
	ENDM
	ENDM
;
CHECK	0C0D0h
; set b,r 
	IRPC	b,01234567
	IRPC	r,bcdehlma
	setx	b r
	ENDM
	ENDM
;
CHECK	100D0h
ends
end