ideal
P186
include	"z-80m.asi"
include	"z80const.asi"
include	"zx-const.asi"
segment	z_80	common
ends
SWSPEED1=64		;  ४祭 ० ⭮ 㧪
SWSPEED2=64
DBLCHANN=1		; 㡫஢  AY-8910
segment	zx_emul
extrn	primap:word
extrn	promap:word
extrn	rdaddr:far
extrn	rdsect:far
extrn	wrsect:far
extrn	fdseek:far
extrn	fdopen:far
extrn	irq1a:near
extrn	irq1:near
extrn	sectbuf:byte
extrn	mousx:word
extrn	mousy:word
extrn	mousbtn:byte
extrn	lpport:word

extrn	@loopm:near
extrn	@loopcb:near
extrn	@loopdd:near
extrn	@looped:near
extrn	@loopfd:near
extrn	@ldar:near
extrn	@loopmr:near
extrn	@loopcbr:near
extrn	@loopddr:near
extrn	@loopedr:near
extrn	@loopfdr:near
extrn	@ldarr:near

ends
segment	z_80
assume	cs:z_80,ss:zx_emul
;	

	org	MLOOPD
	mov	cx,[@halt]
	loop	$
;	org	MLOOP
@mloop:	segfs
	lodsb
	mov	ch,al
;	mov	cl,0		; safe mode
	jmp	cx

	org	21h
	
debug:	mov	dx,D_OFFS
	mov	[@cycle],dx
	sahf
	jmp	dx
;	
	org	D_OFFS
P386
	db	9Ah
	dw	0,188h
	jmp	@mloop
P186
; 
	org	_EMR2
@zz	dw	MLOOP,0CB00h,0DD00h,0ED00h,0FD00h
	dw	0DD00h+PREF_DD,0ED00h+PREF_DD,0FD00h+PREF_DD
	dw	0DD00h+PREF_FD,0ED00h+PREF_FD,0FD00h+PREF_FD
	dw	5F00h+PREF_ED,0
;	
	org	_EMR3
@zz1	dw	@loopm,@loopcb,@loopdd,@looped,@loopfd
	dw	2 dup (@loopdd,@looped,@loopfd)
	dw	@ldar
;	
	org	_EMR4
@zzr	dw	MLOOP,0CB00h,0DD00h,0ED00h,0FD00h
	dw	0DD00h+PREF_DD,0ED00h+PREF_DD,0FD00h+PREF_DD
	dw	0DD00h+PREF_FD,0ED00h+PREF_FD,0FD00h+PREF_FD
	dw	5F00h+PREF_ED,0
;	
	org	_EMR5
@zzr1	dw	@loopmr,@loopcbr,@loopddr,@loopedr,@loopfdr
	dw	2 dup (@loopddr,@loopedr,@loopfdr)
	dw	@ldarr
; 
	org	_EMR0
@emr0:	push	si
	mov	bx,offset @zz
@emr2:	push	ax es
	mov	di,190h
	mov	es,di
	call	@r0
	pop	es ax si
	ret
	
@emr1:	push	si
	mov	bx,offset @zzr
	jmp	@emr2
;		
	org	_EMR1
@r0:	mov	di,[es:bx]
	and	di,di
	jz	@r4
	mov	si,[es:bx+@zz1-@zz]

	call	@r1
	inc	bx
	inc	bx
	jmp	@r0

@r1:	
@@r1:	segss
	lodsb
@@r2:	stosb
	cmp	al,0CCh
	jnz	@@r1
	segss
	lodsb
	cmp	al,0CCh
	jnz	@@r2
@r4:	ret
; 
	org	_INT
	;lahf
	mov	al,[@int]
	shr	al,1
	jnc	zh5
	int	60h
zh5:	shr	al,1
	jnc	zh6
;	jmp	@NMI
;	
zh6:	shr	al,1
	jnc	zh7
	int	62h
zh7:	shr	al,1
	jnc	zh8
	jmp	@INTER
zh8:	sahf
	jmp	dx
;	
	org	_INTER
@INTER:	push	ax
	and	[@int],0f7h
;	and	[@iff],0fbh
	jmp	[@intmod]
;	
@pu1:	mov	dx,[@cycle]
	pop	ax
	jmp	zh8
;	
	org	_INTM0
@im0:	mov	cx,38h
	mov	bx,[@sp]
	lea	bx,[bx-2]
	mov	[@sp],bx
	xchg	cx,si
	mov	dx,offset @pu1
	mov	di,bx
	mov	bl,WR16
	jmp	bx
;	
	org	_INTM1
	mov	cx,38h
@put:	mov	bx,[@sp]
	lea	bx,[bx-2]
	mov	[@sp],bx
	xchg	cx,si
	mov	dx,offset @pu1
	mov	di,bx
	mov	bl,WR16
	jmp	bx
;	
	org	_INTM2
@im2:	mov	bh,[@i]
	mov	bl,0ffh
	cmp	bh,3dh
	mov	cx,[bx]
	jae	@i21
	mov	cx,0ffffh
@i21:	jmp	@put
;  NMI 
	org	_NMI
@NMI:	push	ax
	and	[@int],0fdh
	mov	bx,[@sp]
	lea	bx,[bx-2]
	mov	[@sp],bx
	rcl	[@iff],1
	and	[@iff],0fbh
	mov	cx,66h
	xchg	cx,si
	mov	dx,offset @pu1
	jmp	@nmi2
	
	org	_NMI1
@nmi2:	mov	di,bx
	mov	bl,WR16
	jmp	bx
;   
	org	_KEYB
@i254a:	mov	al,0FFh
@in254:	mov	di,KLAVA
	not	ch
@@x:	shr	ch,1
	jnc	@@n
	and	al,[ss:di]
@@n:	inc	di
	and	ch,ch
	jnz	@@x
	mov	[ss:bx],al
	sahf
	jmp	dx
;   
	org	_BRD
@o254a:	mov	ch,bl
@out254:cli
	mov	di,dx
;	mov	dx,3dah
;	in	al,dx
	mov	dx,3c0h
	mov	al,31h
	out	dx,al
	jmp	brd1
;   
	org	_SOUND
	;lahf
	mov	al,bl
snd:	mov	bx,SBIT
	segss
	xlat
	out	61h,al
	sahf
	jmp	dx
; 
	org	_OUTP1
brd1:	mov	al,ch
	and	al,7
	mov	bx,PAL
	segss
	xlat
	mov	[@brd],al
	out	dx,al
	mov	dx,di
	sti
	mov	al,ch
	jmp	snd
;   
	org	_TAPL0
@@4:	dec	[@intapc]		;  墠
	jnz	@@1
	mov	[@intapc],32
@@4a:	xor	[@intap],40h
	mov	al,[byte @tapts]
	xor	al,1Fh
	mov	[byte @tapts],al
	shr	al,1
	sbb	al,al
	and	[byte @tapts+1],al
@@1:	mov	al,[@intap]
	jmp	@in254
;	
	org	_TAPLA
	mov	ch,bl			; OUT  
	mov	bx,[@tapts]
	mov	al,bl
	inc	bx
	jnz	@@2
	mov	[@intapc],30
	mov	[word ss:promap+508],_TAPLB
@@2:	shr	al,1
	sbb	di,di
	and	bx,di
	mov	[@tapts],bx
	jmp	@out254
;	
	org	_TAPLB
	cmp	[@intapc],31
	jb	@@7
	jmp	@@5
;	
@@7:	mov	[word ss:primap+508],_TAPL0
	mov	[word ss:promap+508],_TAPLA
	mov	[@taptsc],0
	jmp	@o254a
;	
	org	_TAPL1
@@5:	mov	[word ss:primap+508],_TAPLC
	mov	[word ss:promap+508],offset @@7
	mov	[@intapc],3
	mov	[@tapou],_TAPL2
	jmp	@o254a
;	
	org	_TAPLC
	dec	[@intapc]
P386
	jnz	@@1a
P186
	inc	[@taptsb]
	mov	di,[@tapou]
	mov	[ss:promap+508],di
	jmp	@@4a
;	
	org	_TAPL4
@@1a:	cmp	[@taptsb],0
	mov	al,[@b]
	jz	@@1c
	jmp	@@1b
;	
@@1e:	mov	[@taptsc],0
@@1c:	mov	[@taptsb],al
	jmp	@@1
;	
	org	_TAPL5
@@1b:	inc	[@taptsb]
	cmp	[@taptsb],al
P386
	jnz	@@1e
P186
	add	[@taptsc],SWSPEED1
	jnc	@@1d
	mov	[word ss:primap+508],_TAPLF
@@1d:	jmp	@@1
;	
	org	_TAPLF
	cmp	[@intapc],0
P386
	jz	@@1
P186
	mov	al,[@intapc]
	add	[@b],al
	mov	[@intapc],0
	mov	di,[@tapou]
	mov	[ss:promap+508],di
	mov	al,[@l]
	jmp	@@4b
;	
	org	_TAPL6
@@4b:	cmp	al,[@taptsl]
	jnz	@@4e
	add	[@taptsc],SWSPEED2
	jnc	@@4d
	mov	[word ss:primap+508],_TAPLG
@@4e:	mov	[@taptsc],0
@@4d:	jmp	@@4a
;	
	org	_TAPLG
	cmp	[@intapc],0
P386
	jz	@@1
P186
	xor	al,al
	xchg	al,[@intapc]
	cmp	[@l],1
	jz	@@21
@@22:	add	[@b],al
	mov	di,[@tapou]
	mov	[ss:promap+508],di
	jmp	@@4a	
;	
	org	_TAPL7
@@21:	push	bx
	mov	bh,1
	cmp	al,16
	cmc
	rcl	bh,1
P386
	mov	di,[@tapld]
	mov	bl,[gs:di]
	shl	bx,6
	mov	[@l],bh
	shl	bl,1
	mov	[gs:di],bl
P186
	jmp	@@24
;	
	org	_TAPL8
@@24:	sbb	al,al
	and	al,15
	add	al,7
	mov	[@tapsp],al
	pop	bx
	jmp	@@22
;	
	org	_TAPL2
@@5b:	mov	[word ss:promap+508],offset @@7
	mov	[@tapld],2
	mov	[@taptsb],0
P386
	cmp	[word gs:0],0
	jnz	@@5c
	call	@lnxt
@@5c:	inc	[word gs:0]
P186
	jmp	@@5d
;	
	org	_TAPLJ
@@5d:	mov	[@intapc],7
	mov	[@tapou],_TAPLD
	jmp	@o254a
;	
	org	_TAPLD
@@12:	mov	[word ss:promap+508],offset @@77	; ⮢ 
	mov	[@tapou],_TAPLE
	mov	di,[@tapld]
	mov	[@taptsb],0
P386
	shl	[byte gs:di],1
P186
	jz	@@17
	jmp	@@19
;	
	org	_TAPL3
@@17:	inc	di
	mov	[@tapld],di
P386
	dec	[word gs:0]
	jnz	@@18
	
	jmp	@@78
;	
@@18:	mov	[@taptsl],1
	stc
	rcl	[byte gs:di],1
P186
	sbb	al,al
	jmp	@@15
;	
	org	_TAPLE
	mov	[word ss:promap+508],offset @@77
	mov	[@taptsb],0
	mov	[@tapou],_TAPLD
	mov	al,[@tapsp]
	mov	[@intapc],al
	jmp	@o254a
;	
	org	_TAPLH
@@19:	sbb	al,al
	cmp	[@tapsp],16
	cmc
	rcl	[@taptsl],1
@@15:	and	al,15
	add	al,7
@@20:	mov	[@intapc],al
	mov	[@tapsp],al
	jmp	@o254a
;	
	org	_TAPLI
@@77:	call	@lnxt
	jmp	@@78
;	
	org	_TAPL9
@@76:
@@78:	mov	[word ss:primap+508],_TAPL0
	mov	[word ss:promap+508],_TAPLA
	jmp	@o254a
;	
	org	_TAPL10
@lnxt:	mov	ch,0
	int	63h
P386
	cmp	[word gs:0],0
P186
	jnz	@@79
	mov	[word ss:primap+508],_KEYB
	mov	[word ss:promap+508],_BRD
@@79:	ret
;   xxFDh 
	org	_AYS0
@ays:	test	ch,80h
	jnz	@@1
	and	bl,3Fh
	jmp	[@fsys]
;	
@@1:	test	ch,40h
	jz	@@2
	jmp	@ayrg
@@2:	jmp	@aydt
;  ⥬  7FFDh 
P386
extrn	pags:word
extrn	vpags:word
extrn	vhpg:word
extrn	fsysr:word
	org	_SY128
@sy128:	movzx	bx,bl
	mov	[@sysprt],bl
	add	bl,bl

	mov	di,[word ss:pags+bx]
	mov	ds,di
	add	di,0C0h
	mov	fs,di
	mov	di,[word ss:fsysr+bx]
	mov	[@fsys],di
P186
	jmp	@sypg
;	
	org	_SYPG
@sypg:	mov	di,[word ss:vpags+bx]
	mov	[@twpg],di
	mov	ch,ah
	mov	ah,[byte ss:vhpg+bx]
	cli
	mov	di,dx
	mov	dx,3D4h
	mov	al,0Ch
	out	dx,ax
	mov	ah,ch
	mov	dx,di
	sti
	
	sahf
	jmp	dx
; 
	org	_NUL
	sahf
	jmp	dx

	org	_INFF
	mov	[byte ss:bx],0FFh
	sahf
	jmp	dx
;  ஫ 䫮 
	org	_FDC3F
	mov	[@fdc3f],bl
	sahf
	jmp	dx
	org	_FDI3F
	mov	al,[@fdc3f]
	mov	[ss:bx],al
	sahf
	jmp	dx
;	
	org	_FDC5F
	mov	[@fdc5f],bl
	sahf
	jmp	dx
	org	_FDI5F
	mov	al,[@fdc5f]
	mov	[ss:bx],al
	sahf
	jmp	dx
;	
	org	_FDI7F
	mov	di,[@fdbuf]
	mov	al,[ss:di]
	inc	di
	dec	[@fdcntr]
	js	@@1
	mov	[@fdbuf],di
	jz	@@2
	mov	[@fdcqr],40h
	jmp	@@3

	org	_FDI7FA
@@1:	xor	al,al
@@2:	and	[@fdcst],0FCh
	mov	[@fdcntr],0
	mov	[@fdcqr],80h
@@3:	mov	[ss:bx],al
	sahf
	jmp	dx
;	
	org	_FDCFF
@fdff:	mov	[@fdcff],bl
	and	bx,3
	mov	[@flop],bx
	db	9Ah
	dw	fdopen,18h

yyy:	sahf
	jmp	dx
;	
extrn	fdccmds:word
	org	_FDC1F
@fdc1f:	mov	[@fdccm],bl
	mov	bh,0
	add	bx,bx
	mov	di,[@flop]
	jmp	[ss:fdccmds+bx]
;	
@fdi1f:	org	_FDI1F
	mov	al,[@fdcst]
	dec	[@fdind]
	jnz	@@z1
	xor	al,[@fdxor]
@@z1:	mov	[byte ss:bx],al
	sahf
	jmp	dx
;	
	org	_FDIFF
@fdiff:	mov	al,[@fdcqr]
	mov	ch,al
	shl	ch,2
	sbb	ch,ch
	mov	[@fdcqr],ch
	cmp	al,-1
	jz	@fd1
	mov	[byte ss:bx],al
	sahf
	jmp	dx
	
	org	_FDIFFA
@fd1:	mov	[@fdcst],4
	and	[@fdcst],0FCh
	mov	al,80h
	mov	[@fdcntr],0
	mov	[@fdcntw],0
	mov	[@fdcqr],al
	mov	[byte ss:bx],al
	
	sahf
	jmp	dx
;	
	org	_FDHLT
	mov	[@fdccm],0
	mov	al,20h
	cmp	[@fdc5f],0
	jnz	@@2
	or	al,4
@@2:	mov	[@fdcst],al
	mov	[@fdcqr],80h
	mov	[@fdxor],2
	
	sahf
	jmp	dx
;	
	org	_FDPOS0
	xor	al,al
	mov	[@fdc3f],al
	mov	[@fdc5f],al
	mov	[@fdc7f],al
	mov	[@fdccm],al
	mov	[@fdpos+di],al
	mov	[@fsdir],1
	mov	al,24h
	jmp	@z2
;	
	org	_FDSEEK

	mov	al,[@fdc7f]
	sub	al,[@fdc3f]
	add	[@fdc3f],al
	add	al,[@fdpos+di]
	mov	[@fdpos+di],al
	jmp	@z1
	
	org	_FDSEEK1
@z1:	mov	bl,24h
	and	al,al
	jz	@z2
	and	bl,0FBh
	mov	[@fdctr],al
@z2:	mov	[@fdcst],bl
	mov	[@fdcqr],80h
	mov	[@fdxor],2
	db	9Ah
	dw	fdseek,18h
	sahf
	jmp	dx
	
;	
	org	_FDSTEP
	mov	al,[@fsdir]
	add	al,[@fdpos+di]
	mov	[@fdpos+di],al
	jmp	@z1

	org	_FDSTEP1
	mov	al,[@fsdir]
	add	[@fdc3f],al
	add	al,[@fdpos+di]
	mov	[@fdpos+di],al
	jmp	@z1
;	
	org	_FDSTF
	mov	[@fsdir],1
	mov	al,[@fdpos+di]
	inc	al
	mov	[@fdpos+di],al
	jmp	@z1

	org	_FDSTF1
	mov	[@fsdir],1
	mov	al,[@fdpos+di]
	inc	al
	mov	[@fdpos+di],al
	inc	[@fdc3f]
	jmp	@z1
;	
	org	_FDSTB
	mov	[@fsdir],-1
	mov	al,[@fdpos+di]
	dec	al
	mov	[@fdpos+di],al
	jmp	@z1

	org	_FDSTB1
	mov	[@fsdir],-1
	mov	al,[@fdpos+di]
	dec	al
	mov	[@fdpos+di],al
	dec	[@fdc3f]
	jmp	@z1
;	
	org	_FDRDA
@fdrda:	lea	bx,[@fdctr]
	mov	[@fdbuf],bx
	mov	[@fdcntr],6
	mov	[@fdcqr],40h
	mov	[@fdcst],3
	mov	[@fdxor],0
	db	9Ah
	dw	rdaddr,18h
	
	sahf
	jmp	dx
;	
	org	_FDRDS
	mov	[@fdcst],3
	mov	[@fdcqr],40h
	mov	[@fdxor],0
	db	9Ah
	dw	rdsect,18h
	sahf
	jmp	dx

;	
	org	_FDC7F
	mov	[@fdc7f],bl
	cmp	[@fdcntw],0
	jz	@@1
	mov	di,[@fdbuf]
	mov	[ss:di],bl
	inc	di
	mov	[@fdbuf],di
	jmp	@@2
	
@@3:	mov	[@fdcqr],40h
@@1:	sahf
	jmp	dx
	
	org	_FDC7FA
@@2:	dec	[@fdcntw]
	jnz	@@3
	mov	[@fdcqr],80h
	db	9Ah
	dw	wrsect,18h
	sahf
	jmp	dx
;	
	org	_FDWRS
	mov	[@fdcst],3
	mov	[@fdcqr],40h
	mov	[@fdxor],0
	mov	[@fdcntw],256
	mov	[@fdbuf],offset sectbuf

	sahf
	jmp	dx
;	
	org	_FDWRT
	mov	[@fdcst],3
	mov	[@fdcqr],40h
	mov	[@fdxor],0
	mov	[@fdcntw],6300
	mov	[@fdbuf],offset sectbuf
	
	sahf
	jmp	dx
	
;	
	org	_FDRDT
	mov	[@fdcst],3
	mov	[@fdcqr],40h
	mov	[@fdxor],0
	db	9Ah
	dw	rdsect,18h
	sahf
	jmp	dx
;	
;  AY-8910 
	org	_AY1
@ayrg:	mov	al,bl
	lea	bx,[@ayrgs]		; 롮 ॣ AY
	and	al,0Fh
@@1:	add	bl,al
	adc	bh,0
	mov	[@aycur],bx
	add	al,_AYP SHR 8
	mov	[@aycrg],al
	sahf
	jmp	dx
;	
	ORG	_AY2
@aydt:	mov	di,[@aycur]		;   AY
	mov	[ss:di],bl
	mov	al,bl
	mov	bh,[@aycrg]
	mov	bl,_AYP AND 0FFh
	jmp	bx
;	
	org	_AYIS
	mov	al,-1			; ⥭ ॣ AY
	not	ch
	and	ch,0C0h
	jnz	@@1
	mov	di,[@aycur]
	mov	al,[ss:di]
@@1:	mov	[byte ss:bx],al
	sahf
	jmp	dx
;  Regs AY-8910 
irpc	zz,012345
	local	@@ay1,@@ay2,@@1,@@2
	org	_AYP+(zz SHL 8)			;   0,1,2
@@ay1:
	mov	bx,[word @ayrgs+(zz AND 6)]
	and	bx,0FFFh
	add	bx,bx
	mov	bx,[ss:AYFRQS+bx]
	cli
	mov	di,dx
	
	mov	dx,388h
	mov	al,0A0h+(zz SHR 1)
	out	dx,al
	call	@adel2
;	in	al,dx
;	in	al,dx
;	in	al,dx
;	in	al,dx
;	in	al,dx
	inc	dx
	jmp	@@ay2
;	
	ORG	_AYP1+(zz SHL 8)
@@ay2:	mov	al,bl
	out	dx,al
	call	@adel1
;	mov	cx,18h
;@@1:	in	al,dx
;	loop	@@1
	dec	dx
	mov	al,0B0h+(zz SHR 1)
	out	dx,al
	call	@adel2
;	in	al,dx
;	in	al,dx
;	in	al,dx
;	in	al,dx
;	in	al,dx
	inc	dx
	mov	al,bh
	out	dx,al
	call	@adel1
	mov	dx,di
	sti
	sahf
	jmp	dx
;	
endm
	org	_AYP+0600h			;  㬠
	sahf
	jmp	dx
;	
	org	_AYP+0700h			;  ࠧ襭 

irpc	zz,024
	shr	al,1
	sbb	bl,bl
	and	bl,3Fh
	mov	[@aymsk+zz],bl
endm
	or	al,0F8h

	jmp	@ay71
;	
	ORG	_AYP1 + 0700h
@ay71:	add	al,1
	sbb	al,al
	and	al,3Fh
	cli

	mov	[@aymsk+6],al

	mov	di,dx
	mov	dx,388h

	mov	al,043h
	out	dx,al
	mov	bx,[word @aymsk+0]
	call	@setr2

;	mov	cx,12h
	jmp	@ay72
;	
	ORG	_AYP7
@ay72:
	call	@adel1
;@@2:	in	al,dx
;	loop	@@2
	mov	al,044h
	mov	bx,[word @aymsk+2]
	call	@setr2
	
;	mov	cx,12h
	jmp	@ay73
;	
	org	_AYP+0E00h
	sahf
	jmp	dx
;	
@ay73:
	call	@adel1
;@@3:	in	al,dx
;	loop	@@3
	mov	al,45h
	mov	bx,[word @aymsk+4]
	call	@setr2
	
	call	@adel1
;	mov	cx,12h
;@@1:	in	al,dx
;	loop	@@1
	jmp	@ay74

;	
	org	_AYP+0F00h
	sahf
	jmp	dx
;	
@ay74:
	mov	al,054h
	out	dx,al
	
	call	@adel2
;	in	al,dx
;	in	al,dx
;	in	al,dx
;	in	al,dx

	inc	dx
	mov	al,[byte @aymsk+6]
	or	al,[byte @aymsk+7]
	out	dx,al

	call	@adel1

@ay75:	mov	dx,di
	sti
	sahf
	jmp	dx

;	
extrn	musvol:byte
extrn	nsvol:byte
irpc	zz,012
local	@@1,@@2,@@3
	org	_AYP+(zz SHL 8)+0800h		; ஬ 

	mov	bl,al
	and	bx,0Fh
	mov	bl,[ss:musvol+bx]

	mov	[@aymsk+(zz SHL 1)+1],bl
	cli
	mov	di,dx
	mov	dx,388h
	mov	al,43h+zz
	mov	bh,[@aymsk+(zz SHL 1)]
	call	@setr2

	jmp	@@1
;	
	org	_AYOG+(zz SHL 8)
@@1:;	mov	cx,12h
;@@2:	in	al,dx
;	loop	@@2
	call	@adel1
	
	test	[@ayrgs+7],(8 SHL zz)
	jnz	@@3
	mov	al,54h

	out	dx,al
	jmp	@@4
	
@@3:	mov	dx,di
	sti
	sahf
	jmp	dx
;	
endm	
	org	_AYOG1
@@4:
	call	@adel2
;	in	al,dx

	xor	bl,bl
IRPC	zz,012
local	@@a
	test	[@ayrgs+7],(8 SHL zz)
	jnz	@@a
	or	bl,[@ayrgs+zz+8]
@@a:
ENDM
	jmp	@@3
;	
	org	_AYOG1+100h

@@3:	inc	dx
	and	bx,0Fh
	mov	al,[ss:nsvol+bx]
	mov	[@aymsk+7],al
	or	al,[@aymsk+6]
	out	dx,al
	call	@adel1
	
	mov	dx,di
	sti
	sahf
	jmp	dx
	
;	
	org	_AYP+0B00h

	cmp	[@ayrgs+0Ch],0
	jnz	@@pe1
@@pe3:	mov	bx,AYATTK+200h
	mov	ch,al
	segss
	xlat
	xchg	ch,al
	inc	bh
	segss
	xlat
	or	ch,al
	mov	[@ayatdc],ch
	 ;;;
@@pe1:	sahf
	jmp	dx
;	
	org	_AYP+0C00h

	and	al,al
	jnz	@@pe2
	mov	al,[@ayrgs+0Bh]
	jmp	@@pe3
;	
@@pe2:	mov	bx,AYATTK
	mov	ch,al
	segss
	xlat
	xchg	ch,al
	inc	bh
	segss
	xlat
	or	ch,al
	mov	[@ayatdc],ch
	 ;;;
	sahf
	jmp	dx
;	
	org	_AYP+0D00h
	and	al,0Fh
	or	al,(_AYP2 SHR 8)
	mov	bh,al
	mov	[word ss:1Ch],0
	jmp	bx
;	sahf
;	jmp	dx
;	
irpc	zz,01239
	org	_AYP2+(0&zz&h SHL 8)
	mov	ch,[@ayatdc]
	or	ch,0F0h
	mov	[word ss:1Eh],0
	jmp	@setat
endm
;	
irpc	zz,4567F
	org	_AYP2+(0&zz&h SHL 8)
	mov	ch,[@ayatdc]
	or	ch,0Fh
	mov	[word ss:1Eh],0
	jmp	@setat
endm
;	
	org	_AYP2+800h
	
	mov	ch,[@ayatdc]
	or	ch,0F0h
	mov	bx,[ss:1Ah]
	mov	[ss:1Eh],bx
	mov	[@aynwm],ch
	jmp	@setat
;	
	org	_AYP2+0A00h
	mov	ch,[@ayatdc]
	mov	[@aynwm],ch
	or	ch,0F0h
	mov	bx,[ss:1Ah]
	shr	bx,1
	mov	[ss:1Eh],bx
	mov	bx,[word @ayrgs+11]
	shr	bx,1
	mov	[ss:1Ch],bx
	jmp	@setat
;	
	org	_AYP2+0B00h

	mov	ch,[@ayatdc]
	or	ch,0F0h
	mov	[@aynwm],0F0h
	mov	bx,[ss:1Ah]
	mov	[ss:1Eh],bx
	jmp	@setat
;	
	org	_AYP2+0C00h

	mov	ch,[@ayatdc]
	or	ch,0Fh
	mov	[@aynwm],ch
	mov	bx,[ss:1Ah]
	mov	[ss:1Eh],bx
	jmp	@setat
;	
	org	_AYP2+0D00h

	mov	ch,[@ayatdc]
	mov	bx,[ss:1Ah]
	mov	[ss:1Eh],bx
	mov	[@aynwm],0F0h
	jmp	@setat
;	
	org	_AYP2+0E00h

	mov	ch,[@ayatdc]
	mov	[@aynwm],ch
	mov	bx,[ss:1Ah]
	shr	bx,1
	mov	[ss:1Eh],bx
	jmp	@setat
;	
	org	_AYP3
@setat:	cli
	mov	di,dx
	mov	dx,388h
	jmp	@s1
;	
@adel1:	call	@@add1
@@add1:	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
@adel2:	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
	ret
	org	_AYP3+100h
@s1:
;	
irpc	zz,012
	local	@@1,@@2,@@3,@@4
	org	_AYP3+(zz SHL 8)+100h
	mov	al,63h+zz
	mov	bx,0F0h
	test	[@ayrgs+zz+8],10h
	jz	@@2
	mov	bl,ch
	call	@setr2
	mov	dx,zz
	call	@clck
	jmp	@@4
;		
@@2:	call	@setr2
@@4:	call	@adel1
	jmp	@@3
	org	_AYP3+(zz SHL 8)+200h
@@3:
endm
;	
	org	_AYP3+400h
	mov	al,[@ayrgs+8]
	or	al,[@ayrgs+9]
	or	al,[@ayrgs+10]
	test	al,10h
	mov	bl,0F0h
	jz	@@5
	mov	bl,ch
@@5:	call	@setrn
	mov	dx,di
	sti
	sahf
	jmp	dx
;	
	org	_AYP3+500h		; 饫 ⮬ MUTE
@clck:	mov	bh,dl			; DL =   (0,1,2)
	xchg	dx,di
	add	di,di
	mov	di,[word @ayrgs+di]
	and	di,0FFFh
	add	di,di
	mov	bl,[ss:AYFRQS+di+1]
	add	bh,0B0h
	mov	di,dx
	mov	dx,388h
	in	al,dx
	in	al,dx
	in	al,dx
	jmp	@@c1
;	
	org	_AYP3+600h
@@c1:	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
	mov	al,bh
	out	dx,al
	call	@adel2
;	in	al,dx
;	in	al,dx
;	in	al,dx
;	in	al,dx
	inc	dx
	mov	al,bl
	and	al,1Fh
	out	dx,al
	call	@adel1
	mov	al,bl
	out	dx,al
	call	@adel1
	dec	dx
	ret
;	
	org	_AYP3+700h
@setr2:	out	dx,al		; 㧨  ॣ஢ AdLib
	or	bl,bh		; AL  AL-3
	mov	bh,al		; 묨 BL OR BH
	call	@adel2
;	in	al,dx
;	in	al,dx
	mov	al,bl
	inc	dx
	out	dx,al
	dec	dx
IF DBLCHANN
	call	@adel1
	mov	al,bh
	sub	al,3
	out	dx,al
	call	@adel2
;	in	al,dx
;	in	al,dx
;	in	al,dx
	inc	dx
	mov	al,bl
	out	dx,al
	dec	dx
ENDIF
	call	@adel1
	ret
; 
	org	_AYP3+800h
@setrn:	mov	al,74h
	out	dx,al		; 㧨  饫 ॣ 㬠
	call	@adel2
;	in	al,dx
;	in	al,dx
;	in	al,dx
;	in	al,dx
	mov	al,bl
	inc	dx
	out	dx,al
	dec	dx
	call	@adel1
	jmp	@@sr4
; 
	org	_AYP3+900h
@@sr4:	mov	al,0BDh
	out	dx,al
	call	@adel2
;	in	al,dx
;	in	al,dx
;	in	al,dx
;	in	al,dx
;	in	al,dx
	inc	dx
	mov	al,20h
	out	dx,al
	call	@adel1
	call	@adel1
	mov	al,28h
	out	dx,al
	call	@adel1
	dec	dx
	ret
; 
	org	_COV
	cli
	mov	di,dx
	mov	cx,200
	mov	dx,22Ch
@@1:	in	al,dx
	test	al,80h
	loopnz	@@1
	inc	cx
	mov	al,10h
	out	dx,al
@@2:	in	al,dx
	test	al,80h
	loopnz	@@2
	jmp	@@3
;	
	org	_COV1
@@3:	mov	al,bl
	out	dx,al
	mov	cl,0
	mov	dx,di
	sti
	sahf
	jmp	dx
;  Kempston- 
	org	_KMM
	test	ch,1
	jnz	@@k1
	mov	al,[ss:mousbtn]
	not	al
	mov	[ss:bx],al
	sahf
	jmp	dx
;		
	org	_KMM2
@@k1:;	mov	di,bx
	test	ch,4
	jnz	@@k2
	mov	al,[byte ss:mousx+1]
;	shl	bx,2
	mov	[byte ss:bx],al
	sahf
	jmp	dx
;	
@@k2:	mov	al,[byte ss:mousy+1]
;	shl	bx,2
	mov	[byte ss:bx],al
	sahf
	jmp	dx
; 
	org	_LPIN
	cli
	mov	di,dx
	mov	dx,[ss:lpport]
	inc	dx
	in	al,dx
	mov	dl,al
	shl	al,1
	and	al,30h
	xor	al,20h
	or	dl,al
	shl	al,3
	or	al,dl
	rol	al,1
	jmp	@lpin1
;	
	org	_LPIN1
@lpin1:	shl	al,1
	cmp	[@lpptr],1
	rcr	al,1

	mov	[ss:bx],al
;	test	[@lpdata],80h
;	jz	@@p3
;	dec	[@lpptr]
;	jnz	@@p3
;	and	[@lpdata],7Fh

@@p3:	mov	dx,di
	sti
	
	sahf
	jmp	dx

;	
	org	_LPOUT
	test	bl,4
	jnz	@@p1
	test	[@lpdata],80h
	jnz	@@p1a

	shl	bl,1
	mov	bh,LPBUF SHR 8
	mov	bl,[@lpptr]
	rcl	[byte ss:bx],1
	inc	bl
	mov	[@lpptr],bl
	jnz	@@p0
	mov	al,[@lpdata]
	jmp	@@p2

	org	_LPOUT1
@@p2:	inc	al
	or	al,80h
	mov	[@lpdata],al
	test	al,7

	jnz	@@p0
	jmp	@@p6
	
@@p1:	mov	[@lpptr],0
	or	[@lpc],80h
	mov	[@lpdata],0
@@p1a:	and	[@lpdata],7Fh
@@p0:	
	sahf
	jmp	dx

;	
	org	_LPOUT2
@@p6:	cli
	mov	di,dx
	mov	dx,[ss:lpport]
	mov	bx,LPBUF2+81h
	mov	ch,[ss:bx-1]
	call	lprt
	inc	bh
	mov	bl,0
	call	lprt
	jmp	@@p7
;	
	org	_LPOUT3
@@p7:	mov	bl,0C1h
	dec	bh
	mov	ch,[ss:bx-1]
	call	lprt
	mov	dx,di
	sti
	sahf
	jmp	dx
;	

	org	_LPOUT4
lprt:	inc	dx
@lpr2:	push	cx
	mov	cx,50000
@@1:	in	al,dx
	test	al,80h
	loopz	@@1
	pop	cx
	dec	dx
	jmp	@lpr1
;	

	org	_LPOUT5
@lpr1:	mov	al,[ss:bx]
	out	dx,al
	out	dx,al
	inc	dx
	inc	dx
	mov	al,0Dh
	out	dx,al
	in	al,dx
	in	al,dx
	mov	al,0Ch
	out	dx,al
	dec	dx
	inc	bl
	dec	ch
	jnz	@lpr2
	dec	dx
	ret
	
ends	
public	@o254a
public	@emr0
public	@emr1
end