ideal
include	"z-80m.asi"
include	"z80const.asi"
include	"zx-const.asi"
segment	z_80	common
	assume	cs:z_80
;  ROM 
	X=0
REPT	57
	ORG	X+WR8
	sahf
	jmp	dx
;	
	ORG	X+WR16
	mov	cl,0
	sahf
	jmp	dx
	X=X+256
ENDM
; 
	ORG	3900h+WR8
	sahf
	jmp	dx
;	
@wra16a:add	di,di
	mov	di,[ss:AVIDEO-0B000h+di]
	lea	di,[di+bx-1]
	jmp	@wra16b
;	
	ORG	3900h+WR16
	mov	cl,0
	sahf
	jmp	dx
; 
	ORG	3A00h+WR8
	sahf
	jmp	dx
;	
align	4
@wrg16a:add	di,di
	mov	di,[ss:di+VIDEO-8000h]
	mov	[es:di+bx-1],cl
	mov	[es:di+bx+1],ch
	mov	cl,0
	sahf
	jmp	dx
;	
	ORG	3A00h+WR16
	mov	cl,0
	sahf
	jmp	dx
; 
	ORG	3B00h+WR8
	sahf
	jmp	dx
;	
align	4
@wra2:	mov	[es:di+1C2h],al
	mov	al,cl
	mov	cl,0
	and	al,[@flash]
	segss
	xlat
	stosb
	mov	[es:di+3Fh],al
	mov	[es:di+7Fh],al
	jmp	@wrat
;	
	ORG	3B00h+WR16
	mov	cl,0
	sahf
	jmp	dx
; 
	ORG	3C00h+WR8
	sahf
	jmp	dx
;	
align	4
@wra1:	mov	[es:di+82h],al
	mov	[es:di+0C2h],al
	mov	[es:di+102h],al
	mov	[es:di+142h],al
	mov	[es:di+182h],al
	jmp	@wra2
;	
	ORG	3C00h+WR16
	mov	cl,0
	sahf
	jmp	dx
; 
	ORG	3D00h+WR8
	sahf
	jmp	dx
;	
align	4
@wra16:	mov	di,[ss:AVIDEO-0B000h+di]
@wra16b:mov	bx,VIDEO+3000h
	mov	al,ch
	and	al,[@flash]
	segss
	xlat
	mov	[es:di+2h],al
	mov	[es:di+42h],al
	jmp	@wra1
;	
	ORG	3D00h+WR16
	mov	cl,0
	sahf
	jmp	dx
; 
	ORG	3E00h+WR8
	sahf
	jmp	dx
;	
align	4
@wrg16:	mov	[es:di],cl
	mov	[es:di+2],ch
	mov	cl,0
	sahf
	jmp	dx
;	
	ORG	3E00h+WR16
	mov	cl,0
	sahf
	jmp	dx
; 
	ORG	3F00h+WR8
	sahf
	jmp	dx
;	
align	4
@wrat:	mov	[es:di+0BFh],al
	mov	[es:di+0FFh],al
	mov	[es:di+13Fh],al
	mov	[es:di+17Fh],al
	mov	[es:di+1BFh],al
	sahf
	jmp	dx
;	
	ORG	3F00h+WR16
	mov	cl,0
	sahf
	jmp	dx
; 
X=4000h
;  Video RAM (䨪) 
REPT 24
	ORG	X+WR8
	mov	[di],al
	add	di,di
	mov	di,[ss:di+VIDEO-8000h]
	stosb
	sahf
	jmp	dx
;	
	ORG	X+WR16
	mov	[di],cx
	add	di,di
	mov	di,[ss:di+VIDEO-8000h]
	jmp	@wrg16
	
	X=X+256
ENDM
;  Video RAM (ਡ) 
IRPC	Z,012
	ORG	X+WR8
	mov	[di],al
	add	di,di
	mov	di,[ss:AVIDEO-0B000h+di]
@w&z:	mov	bx,VIDEO+3000h
	and	al,[@flash]
	segss
	xlat
	stosb
	mov	[es:di+3Fh],al
	mov	[es:di+7Fh],al
	jmp	@wrat
;	
	ORG	X+WR16
	mov	[di],cx
	add	di,di
	jmp	@wra16
	
	X=X+256
ENDM
; 
REPT	101
	ORG	X+WR8
	mov	[di],al
	sahf
	jmp	dx
;	
	ORG	X+WR16
	mov	[di],cl
	mov	[di+1],ch
	mov	cl,0
	sahf
	jmp	dx
	
	X=X+256
ENDM
;  Video RAM (䨪, ࠭ 2) 
REPT 24
local	@@1,@@2
	ORG	X+WR8
	mov	[di],al
	mov	bx,[@twpg]
	inc	bx
	jz	@@1
	dec	bx
	add	di,di
	mov	di,[ss:di+VIDEO-8000h]
	mov	[es:bx+di],al
@@2:	mov	cl,0
@@1:	sahf
	jmp	dx
;	
	ORG	X+WR16
	mov	[di],cx
	mov	bx,[@twpg]
	inc	bx
	jz	@@2
	jmp	@wrg16a
	
	X=X+256
ENDM
;  Video RAM (ਡ, ࠭ 2) 
REPT	3
local	@@1,@@2
	ORG	X+WR8
	mov	[di],al
	mov	bx,[@twpg]
	inc	bx
	jnz	@@1
@@2:	mov	cl,0
	sahf
	jmp	dx
;	
@@1:	add	di,di
	mov	di,[ss:AVIDEO-0B000h+di]
	lea	di,[di+bx-1]
	jmp	@w0
;	
	ORG	X+WR16
	mov	[di],cx
	mov	bx,[@twpg]
	inc	bx
	jz	@@2
	jmp	@wra16a
	
	X=X+256
ENDM
; 
REPT	36
	ORG	X+WR8
	mov	[di],al
	sahf
	jmp	dx
;	
	ORG	X+WR16
	mov	[di],cl
	mov	[di+1],ch
	mov	cl,0
	sahf
	jmp	dx
	
	X=X+256
ENDM
; 
	ORG	0FF00h+WR8
	mov	[di],al
	sahf
	jmp	dx
	
@@1:	mov	[di],ch
@@2:	mov	cl,0
	sahf
	jmp	dx
;	
	ORG	0FF00h+WR16
	mov	[di],cl
	inc	di
	jnz	@@1
	jmp	@@2
ends
end