ideal
P386
DEF_REGS = 1
include	"z80regs.asi"
include	"z80const.asi"
include	"zx-const.asi"
public	_break
segment	zx_emul para
	assume	cs:zx_emul,ds:zx_emul,ss:zx_emul
sysseg	dw	?		; ⥬ ⠡ (8K)
stkseg	dw	?		; ⥪ +   (64K)
emucode	dw	?		; ப (64K)
emudata	dw	?		;   48K:	ROM (16K)
				;			RAM (48K) (pages 5,2,0)
emu128	dw	?		;   128K:ROM128 (16K)
				;			TRDOS  (16K)
				;			RAM    (80K) (pages 1,3,4,6,7)
				;		extra	ROM    (16K)
tapseg	dw	?		;  -뢮 (64K)
key	dw	0
timc	dw	?		; ६
;PICMASK = 0FCh
KEYLOCK	= 2	; 0 or 2
; 
;BREAK_LOAD=565h
BREAK_SAVE=4D5h
; 
macro	halt	n
 rept n
 	jcxz $+2
 endm
endm
	org	10h
	dw	entry		; 窠 室 (10h)
	dw	0		;	      (12h)
pcode	dd	0		; 窠 室  debugger (14h)
timec	dw	0		;  ⠩ (18h)
aytt	dw	0		; ਮ  AY-8910 (1Ah)
aytc	dw	0		; 稪  AY-8910 (1Ch)
ayatc	dw	0		; ⨢ ਮ  AY-8910 (1Eh)
flags	db	8h		; : Ŀ (20h)
				;        
				;                   1 = ᨭ஭  
				;                  1 = ࠧ Covox
				;                 1 = ࠧ debugger
				;                1 = ࠧ AdLib
				;               1 = ࠧ  ॣ R
				;              1 =  ४祭 樨 ॣ R
mous	db	0		;  : 0 = , 10h-13h = Serial, 2-btn, ᮮ. COM1-COM4
covprt	db	0DDh		;  Covox' (22h)
setupd	db	0		;  SETUP' (23h)
mousprt	dw	3F8h		; (24h)
fnames	dw	disk1,disk2,disk3,disk4; TRD-᪨ (26h)
diskh	dw	0,0,0,0		; Handles  TRD-᪠ (2Eh)
;	
macro	callrm	off
	mov	[ss:rm],offset off
	call	_callrm
endm
;		
align	4
entry:
	mov	eax,cr0
	test	al,1
	jz	@@1
	mov	ax,1020h		; PM not available
	stc
	retf
;	

@@1:	push	cs
	pop	ds
	
	mov	[rets],cs
;	mov	[rets1],cs
	mov	[rets2],cs
;	mov	[rets3],cs
	
	mov	bx,[sysseg]
	mov	es,bx
	cld
	xor	di,di
	xor	ax,ax
	mov	cx,4096
	rep	stosw
	
	
	mov	di,10h
	mov	cx,3FFh
	xor	esi,esi
	mov	dl,92h
	call	@putgdt			; NULL (0)
	movzx	esi,[sysseg]
	shl	esi,4
	add	esi,10h
	mov	cx,01FFh
	mov	dl,92h
	call	@putgdt			; GDT (8)
	mov	cx,07FFh
	add	esi,200h
	mov	dl,92h
	call	@putgdt			; IDT (10h)

	mov	cx,-1
	movzx	esi,[stkseg]
	shl	esi,4
	mov	dl,9Eh
	call	@putgdt			; CS (18h)
	mov	dl,92h
	call	@putgdt			; SS (20h)
	mov	esi,110000h
	mov	dl,9Eh
	call	@putgdt			; ப (28h)
	mov	esi,120000h
	mov	dl,92h
	call	@putgdt			; IO- (30h)
	mov	esi,140000h
	call	@putgdt			;  (38h)
@@6:	add	esi,10000h
	call	@putgdt			; ᥣ  (40h-0F8h)
					; ᥣ  (100h-180h)
	cmp	esi,3D0000h
	jb	@@6

	movzx	esi,[word pcode+2]	; த⥫᪨  (188h)
	shl	esi,4
	mov	dl,9Eh
	call	@putgdt
	mov	esi,110000h		; ப  ᥣ  (190h)
	mov	dl,92h
	call	@putgdt

;   IDT 
	lea	si,[bx+21h]
	mov	es,si
	xor	di,di
	xor	bx,bx
	mov	cx,33
@@3:	mov	ax,[word intpts+bx]
	stosw
	mov	ax,18h
	stosw
	mov	ax,8600h
	stosw
	xor	ax,ax
	stosw
	inc	bx
	inc	bx
	loop	@@3


	mov	ax,offset irq0
	test	[flags],1
	jz	@@3a
	mov	ax,offset irq0s
@@3a:	mov	[word irqpts],ax

	mov	al,[mous]
	and	al,0F0h
	jz	@@m2
	
	cmp	al,10h
	jnz	@@m1
	mov	ax,offset irqms
	mov	bx,offset irqpts+4*2
	mov	dl,0EFh
	test	[mous],1
	jz	@@m1a
	dec	bx
	dec	bx
	ror	dl,1
@@m1a:	mov	[bx],ax
	and	[picmask],dl
	jmp	@@m2
;	
@@m1:
@@m2:
	test	[flags],2
	jz	@@c1
	mov	bl,[covprt]
	xor	bh,bh
	add	bx,bx
	mov	[promap+bx],_COV
@@c1:
	
	test	[flags],4
	jz	@@d1
	mov	[keytab+42h*2],offset D_F8
@@d1:

	test	[flags],8
	jnz	@@ad
	push	es
	mov	es,[emucode]
	mov	bx,_AYP
@@ad1:	mov	[byte es:bx],9Eh		; sahf
	mov	[word es:bx+1],0E2FFh		; jmp dx
	inc	bh
	cmp	bh,(_AYP SHR 8)+10h
	jb	@@ad1
	
	pop	es
@@ad:

	xor	bx,bx
	mov	di,400h
	mov	cx,8
@@11:	mov	ax,[word irqpts+bx]
	stosw
	mov	ax,18h
	stosw
	mov	ax,8600h
	stosw
	xor	ax,ax
	stosw
	inc	bx
	inc	bx
	loop	@@11

	mov	di,60h*8
	mov	ax,offset int60
	stosw
	mov	ax,18h
	stosw
	mov	ax,8600h
	stosw
	xor	ax,ax
	stosw

	mov	di,63h*8
	mov	ax,offset int63
	stosw
	mov	ax,18h
	stosw
	mov	ax,8600h
	stosw
	xor	ax,ax
	stosw
	

;   PTT 
;	int	3
	mov	bx,[sysseg]
	mov	es,bx
	movzx	eax,bx
	shl	eax,4
	or	al,67h
	add	eax,1000h
	mov	[es:0],eax
	xor	eax,eax
	lea	ax,[bx+100h]
	mov	es,ax
	
	xor	di,di
	mov	cx,256
	mov	eax,67h
@@10:	stosd
	add	eax,1000h
	loop	@@10
	
	movzx	eax,bx
	shl	eax,4
	add	eax,1067h
	stosd			; PAGE 100h 
	sub	eax,1000h
	stosd			; PAGE 101h (GDT,IDT)
	movzx	eax,bx
	mov	cx,14		; PAGES 102h-10Fh (reserved)
	rep	stosd
	dec	cx
	movzx	eax,[emucode]
	call	@putseg		; PAGES 110h-11Fh (ப)
	movzx	eax,[tapseg]
	call	@putseg		; PAGES 120h-12Fh ( -뢮)
	movzx	eax,[stkseg]
	call	@putseg		; PAGES 130h-13Fh (⥪)
	mov	eax,0B800h
	mov	cx,8
	call	@psu		; PAGES 140h-147h ()
	mov	eax,0B000h
	mov	cx,8
	call	@psu		; PAGES 148h-14Fh ( )

	;int	3
	xor	esi,esi
@@7:	rol	esi,16
@@8:	mov	cx,4
	mov	bx,[word rompts+si]
	mov	ax,[word bx]
	add	ax,[word rompts+si+2]
	movzx	eax,ax
	call	@psu
	rol	esi,16
	mov	cx,8
	mov	ax,[emudata]
	add	ax,400h
	movzx	eax,ax
	call	@psu
	mov	cx,4
	mov	bx,[word rampts+si]
	mov	ax,[word bx]
	add	ax,[word rampts+si+2]
	movzx	eax,ax
	call	@psu
	add	si,4
	cmp	si,32
	jb	@@7
	xor	si,si
	rol	esi,16
	add	si,4
	cmp	si,12
	jb	@@8

	xor	si,si
@@9:	mov	ax,[emu128]
	add	ax,1C00h
	movzx	eax,ax
	shl	eax,4
	or	al,67h
	stosd
	mov	cx,2
	mov	bx,[word rompts]
	mov	ax,[word bx]
	add	ax,[word rompts+2]
	add	ax,100h
	movzx	eax,ax
	call	@psu
	mov	ax,[emu128]
	add	ax,1D00h
	movzx	eax,ax
	shl	eax,4
	or	al,67h
	stosd
	mov	cx,8
	mov	ax,[emudata]
	add	ax,400h
	movzx	eax,ax
	call	@psu
	mov	cx,4
	mov	bx,[word rampts+si]
	mov	ax,[word bx]
	add	ax,[word rampts+si+2]
	movzx	eax,ax
	call	@psu
	add	si,4
	cmp	si,32
	jb	@@9

	xor	si,si
@@a:	mov	cx,4
	mov	bx,[word rompts+4]
	mov	ax,[word bx]
	add	ax,[word rompts+6]
	movzx	eax,ax
	call	@psu
	mov	cx,8
	mov	ax,[emudata]
	add	ax,400h
	movzx	eax,ax
	call	@psu
	mov	cx,4
	mov	bx,[word rampts+si]
	mov	ax,[word bx]
	add	ax,[word rampts+si+2]
	movzx	eax,ax
	call	@psu
	add	si,4
	cmp	si,32
	jb	@@a

	mov	bx,[word rompts+8]
	mov	ax,[word bx]
	add	ax,[word rompts+10]
	movzx	eax,ax
	mov	cx,4
	call	@psu
	mov	cx,12
	mov	ax,[emu128]
	add	ax,1F00h
	movzx	eax,ax
	shl	eax,4
	or	al,67h
	rep	stosd

;  ७ ⠡ 
;	push	ss
;	pop	es
;	
;	mov	si,offset video2
;	mov	di,VIDEO+3000h
;	mov	cx,128
;	rep	movsw

;  ⠭ Breakpoint' 
	;int	3
	mov	ax,[emu128]
	add	ax,1C00h
	mov	es,ax
	mov	ax,[emudata]
	mov	ds,ax
	xor	si,si
	xor	di,di
	mov	cx,800h
	rep	movsw
	mov	si,3000h
	mov	cx,800h
	rep	movsw
	mov	ax,[ss:emu128]
	add	ax,300h
	mov	ds,ax
	xor	si,si
	mov	cx,800h
	rep	movsw
	mov	cx,800h
	mov	ax,0C7C7h
	rep	stosw
	mov	di,1D00h
	mov	cx,80h
	rep	stosw

;	mov	[byte es:BREAK_LOAD],al ; Break on load
;	mov	[byte es:BREAK_SAVE],al ; Break on save

;  室  Protected Mode 	
	;int	3
	push	ss
	pop	ds
	mov	[old_st],sp
	mov	[old_st+2],ss

	sub	sp,200h
	mov	[new_st],sp

	mov	es,[sysseg]
	cli

	in	al,21h
	mov	[oldpic],al
; 
	xor	ax,ax
	mov	fs,ax
irpc	x,01234567
	mov	[word fs:8&x&h*4],offset int8&x
	mov	[word fs:8&x&h*4+2],cs
endm
; 
	mov	al,11h		; 让 ਢ 騪!!!
	out	20h,al
	mov	al,80h
	out	21h,al
	mov	al,4
	out	21h,al
	mov	al,0Dh
	out	21h,al
	mov	al,[cs:picmask]
	out	21h,al
; 
	movzx	eax,[sysseg]
	shl	eax,4
	mov	cr3,eax
	lgdt	[qword es:18h]
	lidt	[qword es:20h]
	mov	eax,cr0
	or	eax,80000001h
	mov	cr0,eax

	db	0EAh
	dw	@@4,18h
@@4:	lss	sp,[dword cs:new_st]
	mov	ax,20h
	mov	es,ax
	mov	ax,40h
	mov	ds,ax
	cld
	mov	di,offset regs
	xor	ax,ax
	mov	cx,80h
	rep	stosw
	mov	bp,offset regs

	cld
	mov	ax,38h
	mov	es,ax		; Startup mode	
	mov	[@sysprt],10h	; 0 = 128K, 10h = 48K
	movzx	bx,[@sysprt]
	and	bl,3Fh
	add	bx,bx
	mov	ax,[word ss:pags+bx]
	mov	ds,ax
	add	ax,0C0h
	mov	fs,ax
	mov	ax,[word ss:fsysr+bx]
	mov	[@fsys],ax
	mov	ax,[word ss:vpags+bx]
	mov	[@twpg],ax

	mov	ax,30h
	mov	gs,ax

	mov	[@int],0
	mov	[@flash],0FFh
;	mov	[@prt_o],_OUTP
	mov	[@cycle],MLOOP
;	mov	[@lpc],80h
	mov	[@lpptr],0
	mov	[@lpdata],80h
	mov	[@iff],0
	mov	[@im],0
	mov	[@r],0

	push	es
	mov	ax,190h
	mov	es,ax
	test	[ss:flags],10h
	jz	@@r1
	or	[@r],1
	mov	bx,0
@@r5:	mov	di,[es:bx+_EMR4]
	mov	si,[es:bx+_EMR5]
	and	di,di
	jz	@@r1
	call	putc1
	inc	bx
	inc	bx
	jmp	@@r5
;	
@@r1:	test	[ss:flags],20h
	jz	@@r2
	mov	si,offset @ei
	mov	di,0FB00h
	call	putc1
	mov	si,offset @ldra
	mov	di,04F00h+PREF_ED
	call	putc1
@@r2:	pop	es

	mov	[@intmod],_INTM0
	mov	[@twpg],-1
	mov	[@fsys],_SY128
	mov	[@intap],-1
	lea	ax,[@ayrgs]
	mov	[@aycur],ax
	mov	[@aycrg],_AYP SHR 8
	mov	dx,3DAh
	in	al,dx
	xor	di,di
@@a2:	mov	[byte @aymsk+di],3Fh
	inc	di
	cmp	di,8
	jb	@@a2
	cmp	[word gs:0],0
	jz	@@a1
	mov	[ss:primap+508],_TAPL0
	mov	[ss:promap+508],_TAPLA
@@a1:
;	mov	dx,[@cycle]
	mov	dx,_INT
	or	[@int],1
	mov	[ss:setupd],4
	mov	[@trdos],0

	xor	ax,ax
	xor	si,si
	xor	cx,cx
	sti
	mov	bl,[@sysprt]
	jmp far 28h:0
;	
putc1:	segss
	lodsb
@@r4:	stosb
	cmp	al,0CCh
	jnz	putc1
	segss
	lodsb
	cmp	al,0CCh
	jnz	@@r4
	retn
;  ࠡ稪 뢠 ॠ쭮 ० 
int80:;	push	ax
;	mov	ax,[cs:timec]
;	add	[cs:timcou],ax
;	jnc	@sk
;	pop	ax
	int	8
	iret
;@sk:	mov	al,20h
;	out	20h,al
;	pop	ax
;	iret
int81:	int	9		; Locked!!!
	iret
int82:	int	10
	iret
int83:	int	11
	iret
int84:	int	12
	iret
int85:	int	13
	iret
int86:	int	14
	iret
int87:	int	15
	iret
;  ࠡ稪 뢠 饭 ० 
;	INT	20h  - ଠ 室  PM
;	INT	10h  - 뢠 REAL INT 10h,   DS  ES  [TAPSEG]
;	
IRP	x,0,1,2,3,4,5,6,7,8,9,10,11,15,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32;,33
	align	4
int&x:	mov	[byte ss:timc],x
	jmp	exept
ENDM
;	
IRP	x,12,13,14
	align	4
int&x:	mov	[byte ss:timc],x
	jmp	exept2
ENDM
;	
IRP	x,2,3,4,5,6,7
	align	4
irq&x:	push	ax
	mov	al,20h
	out	20h,al
	pop	ax
	iret
ENDM
;	
int16:	callrm	i16
	iret
i16:	int	10h
	retn
;	
int63:	callrm	i63
	iret
i63:	int	63h
	retn
;	
int60:	mov	[@pc],si
	mov	[@f],ah
	
	mov	bl,[@trdos]
	mov	[ss:oldtr],bl
	
	callrm	i60
	cli
	test	[ss:setupd],1
	jz	@@is1
	mov	[ss:timc],20h
	jmp	exept
;		
@@is1:	and	[@int],0FEh

	movzx	bx,[@sysprt]
	and	bl,3Fh
	add	bl,bl

	mov	di,[word ss:pags+bx]
	mov	ds,di
	add	di,0C0h
	mov	fs,di

	call	@actrd

	mov	di,[word ss:fsysr+bx]
	mov	[@fsys],di
	mov	di,[word ss:vpags+bx]
	mov	[@twpg],di
	mov	ah,[byte ss:vhpg+bx]
	mov	dx,3D4h
	mov	al,0Ch
	out	dx,ax

	mov	dx,[@cycle]
	mov	si,[@pc]
	mov	ah,[@f]
	mov	bx,_INTM0
	mov	al,[@im]
	and	al,al
	jz	@@is2
	mov	bx,_INTM1
	dec	al
	jz	@@is2
	mov	bx,_INTM2
@@is2:	mov	[@intmod],bx
	iret

i60:	int	60h
	retn
;	
align	4
irq0s:	push	ax dx

	mov	dx,3DAh

	in	al,dx			; ⠥:
	test	al,8			;  ३     
	jz	@@i2
	dec	[ss:timec]		; ᫨ 㦥 , 㦭 㬥 
	jmp	@@i3			; ⥫ ⠩
;	
@@i2:	in	al,dx			;  ⥯ - ३  
	test	al,8			; ᫨ -  砫 - 㢥
	jnz	@@i1			; ⥫ ⠩
	inc	[ss:timec]
@@i2a:	in	al,dx			;  ० 祬   - 
	test	al,8			; 砫 ३
	jz	@@i2a
@@i3:	mov	al,34h			; 堥 ࠢ 祭  ⠩
	out	43h,al	
	mov	ax,[ss:timec]
	dec	ax
	out	40h,al
	jcxz	$+2
	jcxz	$+2
	mov	al,ah
	out	40h,al
	
@@i1:	pop	dx
	jmp	irq0a
;	
align	4
irq0:	push	ax
irq0a:	test	[@_iff],4
	jz	@@1
	mov	dx,_INT
	or	[@_int],8
	and	[@_iff],0FBh
@@1:	mov	ax,[ss:ayatc]
	and	ax,ax
	jz	@@2
	add	ax,[ss:aytc]
	cmp	ax,[word @ayrgs+11]
	jb	@@4
	sub	ax,[word @ayrgs+11]
	cmp	ax,[word @ayrgs+11]
	mov	[ss:aytc],ax
	jb	@@5
	mov	[ss:ayatc],0
	mov	[@aynwm],0F0h
@@5:	call	@chadl
	mov	al,20h
	out	20h,al
	pop	ax
	iret
;	
@@4:	mov	[ss:aytc],ax
@@2:	mov	al,20h
	out	20h,al
	pop	ax
	iret
;  ࠡ稪 Serial mouse 
align	4
irqms:	push	ax dx di
	mov	dx,[ss:mousprt]
	mov	di,[ss:mousbuf]
	in	al,dx
	test	al,40h
	jz	@@m1
	mov	di,offset mouscmd
@@m1:	and	al,3Fh
	mov	[ss:di],al
	inc	di
	cmp	di,offset mouscmd+3
	ja	@@m2
	jb	@@m3

	mov	dl,[ss:di-3]
	ror	dl,2
	mov	al,dl
	and	al,0C0h
	or	al,[ss:di-2]
	imul	[ss:mousmx]
	shl	ax,2
	add	[ss:mousx],ax
	ror	dl,2
	mov	al,dl
	and	al,0C0h
	or	al,[ss:di-1]
	imul	[ss:mousmy]
	shl	ax,2
	add	[ss:mousy],ax
	and	dl,3
	mov	[ss:mousbtn],dl
@@m3:	mov	[ss:mousbuf],di
@@m2:	mov	al,20h
	out	20h,al
	pop	di dx ax
	iret
;	
proc	@chadl
	push	dx cx bx
	mov	dx,388h
	mov	ch,[@aynwm]
irpc	zz,012
local	@@1,@@2,@@3,@@4
	test	[byte @ayrgs+8+zz],10h
	jz	@@1
	mov	al,63h+zz
	out	dx,al
	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
	inc	dx
	mov	al,ch
	out	dx,al
	dec	dx
	mov	cl,12h
@@2:	in	al,dx
	dec	cl
	jnz	@@2
	mov	al,60h+zz
	out	dx,al
	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
	inc	dx
	mov	al,ch
	out	dx,al
	dec	dx
	mov	cl,10h
@@3:	in	al,dx
	dec	cl
	jnz	@@3
	mov	bx,[word @ayrgs+(zz SHL 1)]
	and	bx,0FFFh
	add	bx,bx
	mov	bl,[byte ss:AYFRQS+bx+1]

	mov	al,0B0h+zz
	out	dx,al
	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
	inc	dx
	mov	al,bl
	and	al,1Fh
	out	dx,al
	mov	cl,12h
@@4:	in	al,dx
	dec	cl
	jnz	@@4
	mov	al,bl
	out	dx,al
	dec	dx
@@1:
endm
	mov	al,[@ayrgs+8]
	or	al,[@ayrgs+9]
	or	al,[@ayrgs+10]
	test	al,10h
	jz	@@6
	mov	al,74h
	out	dx,al
	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
	inc	dx
	mov	al,ch
	out	dx,al
	dec	dx
	mov	cl,12h
@@5:	in	al,dx
	dec	cl
	jnz	@@5
	mov	al,0BDh
	out	dx,al
	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
	inc	dx
	mov	al,20h
	out	dx,al
	mov	cl,16h
@@7:	in	al,dx
	dec	cl
	jnz	@@7
	mov	al,28h
	out	dx,al
@@6:	pop	bx cx dx
	ret
endp
;	
align	4
irq1:	push	ax bx
	in	al,60h
	mov	bl,al
	mov	ah,1
	mov	[ss:key],ax
	in	al,61h
	or	al,80h
	out	61h,al
	and	al,7Fh
	out	61h,al
	mov	al,20h
	out	20h,al
	mov	bh,0
	add	bx,bx
	jmp	[cs:keytab+bx]
	
;	cmp	bl,2
;	jnz	keydone
;	mov	dl,20h
;	jmp	exept
	
;	
keydone:mov	al,[ss:grey]
	dec	al
	js	@@1
	mov	[ss:grey],al
@@1:	pop	bx ax
	iret
;	
align	4
;	
proc	_callrm	near
	pushf
	cli
	push	ds es fs gs
	pusha
	push	eax
	mov	eax,cr0
	mov	[ss:oldcr0],eax
	and	eax,07FFFFFFEh
	mov	cr0,eax
	db	0EAh
	dw	offset @@1
rets2	dw	?
@@1:	mov	ax,cs
	mov	ss,ax
	mov	es,[cs:sysseg]
	lidt	[qword es:10h]
	mov	ax,[cs:tapseg]
	mov	ds,ax
	mov	es,ax
	mov	al,[cs:oldpic]
	or	al,KEYLOCK
	out	21h,al
	pop	eax
	call	[ss:rm]
	push	eax
	cli
	mov	al,[cs:picmask]
	out	21h,al
	mov	es,[cs:sysseg]
	lgdt	[qword es:18h]
	lidt	[qword es:20h]
	movzx	eax,[cs:sysseg]
	shl	eax,4
	mov	cr3,eax
	mov	eax,[cs:oldcr0]
	mov	cr0,eax
	db	0EAh
	dw	@@2,18h
@@2:	mov	ss,[cs:new_st+2]
	pop	eax
	popa
	pop	gs fs es ds
	popf
	ret
endp
;	
;	
;error:;	mov	ax,30h
;	mov	es,ax
;	mov	cx,8000h
;	xor	si,si
;	xor	di,di
;	rep	movsw
	
;	jmp	exept
;	
align	4
exept2:	pop	[ss:exstat]
exept:	enter	0,0
	pusha
	mov	dl,[byte ss:timc]
	mov	[ss:timc],sp
	mov	eax,cr0
	and	eax,07FFFFFFEh
	mov	cr0,eax
	db	0EAh
	dw	offset reti
rets	dw	?
reti:	lss	sp,[dword cs:old_st]
	mov	es,[cs:sysseg]
	lidt	[qword es:10h]

	cli
	mov	al,11h
	out	20h,al
	halt	2
	mov	al,8
	out	21h,al
	halt	2
	mov	al,4
	out	21h,al
	halt	2
	mov	al,1
	out	21h,al
	halt	2

	mov	al,0FFh
	out	21h,al

	sti
	xor	dh,dh
	cmp	dl,20h
	jz	@@5
	stc
	mov	dh,10h
	
;	mov	si,offset str1
;	call	outstr
;	mov	al,dl
;	call	outhexb
;	mov	si,offset str2
;	call	outstr
;	mov	eax,edi
;	call	outhexp

;	mov	si,offset str3
;	call	outstr

@@5:	mov	al,[cs:oldpic]
	out	21h,al
	
	mov	ax,dx
;	mov	dx,di
;	shr	edi,16
;	mov	cx,di
;	int	3
	retf
;	
outstr:	cld
@@2:	segss
	lodsb
	and	al,al
	jz	@@1
	mov	ah,0Eh
	int	10h
	jmp	@@2
;	
@@1:	ret
;	
str1	db	'Exeption ',0
str2	db	' at ',0
str3	db	13,10,0
; 
proc	@putgdt	near
	mov	ax,cx
	stosw
	movzx	ax,dl
	shl	eax,24
	add	eax,esi
	stosd
	xor	ax,ax
	stosw
	ret
endp
; 
proc	@putseg
	mov	cx,16
@psu:	shl	eax,4
	or	al,67h
@@1:	stosd
	add	eax,1000h
	loop	@@1
	ret
endp
; 
_break:	dec	si
	mov	bx,fs
	cmp	bx,180h
	jnz	@@1
;	cmp	[@trdos],0
;	jz	@@1
	cmp	si,4000h			;  TR-DOS
	jb	@@2
	mov	[@trdos],0
	mov	bx,ds
	sub	bx,80h
	mov	ds,bx
	add	bx,0C0h
	mov	fs,bx
	mov	di,offset fdprts
IRPC	x,1357F
; 	mov	bx,[ss:fdprts+di]
 	mov	bx,[ss:di]
 	mov	[ss:primap+0&x&Fh*2],bx
 	inc	di
 	inc	di
ENDM
IRPC	x,1357F
; 	mov	bx,[ss:fdprts+di]
 	mov	bx,[ss:di]
 	mov	[ss:promap+0&x&Fh*2],bx
 	inc	di
 	inc	di
ENDM
	retf
;	
@@1:	mov	bx,si
	cmp	bh,3Dh
	jnz	@@0
	mov	[@trdos],1
	mov	bx,ds				; ⨢஢ TR-DOS
	add	bx,80h
	mov	ds,bx
	mov	bx,180h
	mov	fs,bx
	mov	di,offset fdprts
IRPC	x,1357F
	mov	bx,_FDI&x&F
 	xchg	bx,[ss:primap+0&x&Fh*2]
; 	mov	[ss:fdprts+di],bx
 	mov	[ss:di],bx
 	inc	di
 	inc	di
ENDM
IRPC	x,1357F
	mov	bx,_FDC&x&F
 	xchg	bx,[ss:promap+0&x&Fh*2]
; 	mov	[ss:fdprts+di],bx
 	mov	[ss:di],bx
 	inc	di
 	inc	di
ENDM
	retf
;	
@@0:;	cmp	si,BREAK_LOAD
;	jz	@@L
	cmp	si,BREAK_SAVE
	jz	@@S

@@2:	int	61h
	xor	si,si
	retf
;	
@@L:
@@S:
	enter	0,0
	lodsb
	mov	[bp+3],al
	mov	[byte bp+2],0
	leave
	sahf
	retf
; 
proc	@actrd
	push	bx di
	cmp	[@trdos],0
	jz	@@1
	cmp	[ss:oldtr],0
	jnz	@@0
	mov	[ss:oldtr],1
	mov	bx,ds				; ⨢஢ TR-DOS
	add	bx,80h
	mov	ds,bx
	mov	bx,180h
	mov	fs,bx
	mov	di,offset fdprts
IRPC	x,1357F
	mov	bx,_FDI&x&F
 	xchg	bx,[ss:primap+0&x&Fh*2]
 	mov	[ss:di],bx
 	inc	di
 	inc	di
ENDM
IRPC	x,1357F
	mov	bx,_FDC&x&F
 	xchg	bx,[ss:promap+0&x&Fh*2]
 	mov	[ss:di],bx
 	inc	di
 	inc	di
ENDM
	jmp	@@0
;	
@@1:	cmp	[ss:oldtr],0
	jz	@@0
	mov	[ss:oldtr],0
	mov	bx,ds
	sub	bx,80h
	mov	ds,bx
	add	bx,0C0h
	mov	fs,bx
	mov	di,offset fdprts
IRPC	x,1357F
 	mov	bx,[ss:di]
 	mov	[ss:primap+0&x&Fh*2],bx
 	inc	di
 	inc	di
ENDM
IRPC	x,1357F
 	mov	bx,[ss:di]
 	mov	[ss:promap+0&x&Fh*2],bx
 	inc	di
 	inc	di
ENDM
@@0:	pop	di bx
	ret
endp
; 
proc	rdaddr	far
	mov	al,[@fdc3f]
	mov	[@fdc5f],al
	mov	ax,[ss:curh]
	inc	ax
	jnz	@@1
@nord:	mov	[@fdcntr],0
	mov	[@fdcntw],0
	mov	[@fdcqr],80h
	mov	[@fdcst],10h
@@1:	ret
endp
; 
proc	rdsect	far
	mov	ax,[ss:curh]
	inc	ax
	jz	@nord
	callrm	@rdsect
	ret
endp
; 
proc	wrsect	far
	mov	al,[@fdccm]
	and	al,0E0h
	cmp	al,0A0h
	jnz	@@1
	mov	ax,[ss:curh]
	inc	ax
	jz	@nord
@@1:	callrm	@wrsect
	ret
endp
; 
proc	fdseek	far
	pushf
	and	[@fdcst],7Fh
;	cmp	[ss:curh],-1
;	jnz	@@1
;	or	[@fdcst],80h
;	mov	[@fdxor],0
@@1:	popf
	ret
endp
; 
proc	fdopen	far
	mov	[@fdcln],1
	mov	[@fdchd],0
	callrm	@fdopen
	ret
endp
; 
public	prtin
proc	prtin	far
	callrm	@pp1
	retf
endp
; 
proc	beep	near
	mov	ax,0E07h
	int	10h
	ret
endp
; 
proc	@pp1	near
	mov	ds,[ss:emudata]
	in	al,21h
	and	al,0FDh
	out	21h,al
	int	3
	ret
endp
; 
proc	@fdopen
	mov	[ss:curh],-1
	mov	[ss:curprot],0
	call	opendsk
	jc	@@1
	jz	@@2
	mov	[ss:curprot],40h
@@2:	mov	[ss:curh],ax
	and	[@fdcst],7Fh
	ret
;	
@@1:	or	[@fdcst],80h
	ret
endp
; 
proc	@rdsect	near
	push	ss
	pop	ds
	push	ss
	pop	es
	mov	ax,[curh]

	mov	ch,[@fdccm]
	and	ch,0F0h
	cmp	ah,0E0h
	jnz	@@s
	xor	ch,ch
	mov	[@fdtmc],ch
	call	seekdsk
	
	mov	di,offset sectbuf
	mov	[@fdbuf],di
	mov	si,[@flop]
@@s1:	mov	cx,10
	mov	al,4Eh
	rep	stosb
	mov	cl,12
	mov	al,0
	rep	stosb
	mov	al,0A1h
	stosb
	stosb
	stosb
	mov	al,0FEh
	stosb
	mov	al,[@fdpos+si]
	stosb
	mov	al,0
	stosb
	mov	al,[@fdtmc]
	inc	al
	stosb
	mov	al,1
	stosb
	stosb
	stosb
	mov	cl,22
	mov	al,4Eh
	rep	stosb
	mov	al,0
	mov	cl,12
	rep	stosb
	mov	al,0A1h
	stosb
	stosb
	stosb
	mov	al,0FBh
	stosb
	mov	dx,di
	mov	cx,256
	mov	ah,3Fh
	int	21h
	add	di,cx
	xor	al,al
	stosb
	stosb
	mov	al,4Eh
	mov	cx,50
	rep	stosb
	inc	[@fdtmc]
	cmp	[@fdtmc],10h
	jb	@@s1
	mov	cx,6300
	mov	[@fdcntr],cx
	sub	cx,di
	add	cx,[@fdbuf]
	rep	stosb
	and	[@fdcst],023h
	ret
;	
@@s:	mov	ch,0FFh
	call	seekdsk
	jc	@@0
	
	test	[@fdccm],10h
	mov	cx,100h
	jz	@@7
;	int	3
	not	ax
	and	ax,0F00h
	inc	ah
	mov	cx,ax

@@7:	mov	dx,offset sectbuf
	mov	ah,3Fh
	int	21h
	jc	@@0
	cmp	ax,cx
	jnz	@@0
	
	mov	[@fdcntr],ax
	mov	[@fdbuf],dx
	
	and	[@fdcst],023h
	ret
;	
;@@1:
;	mov	[@fdcst],84h
;	mov	[@fdcqr],80h
;	ret
;	
@@0:	or	[@fdcst],10h
	and	[@fdcst],23h
	or	[@fdcqr],80h
	ret
endp
; 
proc	@wrsect
	push	ss
	pop	ds
	mov	al,[@fdccm]
	and	al,0F0h
	cmp	al,0F0h
	jnz	@@w
;	int	3
	mov	ax,[ss:curh]
	inc	ax
	jnz	@@f1
	call	creadsk
	jc	@@0
	inc	ax
@@f1:	dec	ax
	mov	bx,ax
	cmp	[ss:curprot],0
	jnz	@@2
	cld
	mov	si,offset sectbuf
@@f4:	mov	ah,0F5h
	call	scandsk
	jc	@@f2
	lodsb
	lodsb
	lodsb
	cmp	al,0FEh
	jnz	@@0
	lodsb
	cmp	al,[@fdc3f]
	jz	@@f5
	mov	[@fdctr],al
@@f5:	lodsb
	lodsb
	mov	ch,al
	dec	ch
	mov	ah,0F5h
	call	scandsk
	jc	@@f2
	lodsb
	lodsb
	lodsb
	cmp	al,0F8h
	jz	@@f3
	cmp	al,0FBh
	jnz	@@0
@@f3:	call	seek1
	mov	cx,100h
	mov	dx,si
	mov	ah,40h
	int	21h
	jc	@@0
	cmp	ax,cx
	jnz	@@0
	add	si,cx
	cmp	si,offset sectbuf+6300
	jb	@@f4
@@f2:	jmp	@@we
;		
@@w:	and	al,0E0h
	cmp	al,0A0h
	jz	@@w1

	jmp	@@we
;		
@@w1:	mov	ax,[ss:curh]
	inc	ax
	jz	@@1
	dec	ax
	
	cmp	[ss:curprot],0
	jnz	@@2
	mov	ch,0FFh
	call	seekdsk
	jc	@@0
	
	mov	cx,100h
	test	[@fdccm],10h
	jz	@@ws
	not	ax
	and	ax,0F00h
	inc	ah
	mov	cx,ax
	
@@ws:	mov	dx,offset sectbuf
	mov	ah,40h
	int	21h
	jc	@@2
	cmp	ax,cx
	jnz	@@0
	
@@we:	mov	[@fdcst],00h

	ret
;	
@@2:	mov	[@fdcst],60h
	or	[@fdcqr],80h
	ret
;	
@@0:	or	[@fdcst],10h
	or	[@fdcqr],80h
	ret
;	
@@1:	mov	[@fdcst],80h
	and	[@fdcqr],3Fh
	ret
endp
; 
proc	opendsk
	push	ss
	pop	ds

	mov	bl,[@fdcff]
	and	bx,3
	add	bx,bx
	mov	ax,[ss:diskh+bx]
	and	ax,ax
	jnz	@@1
	mov	dx,[ss:fnames+bx]
	mov	ax,3D02h
	int	21h
	jnc	@@2
;	cmp	ax,5
;	jnz	@@0
	mov	ax,3D00h
	int	21h
	jc	@@0
	or	ah,80h
@@2:	mov	[ss:diskh+bx],ax
@@1:	test	ah,80h
	pushf
	and	ah,7Fh
	popf
	clc
	ret
;	
@@0:	stc
	ret
endp
; 
proc	creadsk
	push	ss
	pop	ds

	mov	bl,[@fdcff]
	and	bx,3
	add	bx,bx
	xor	cx,cx
	mov	dx,[ss:fnames+bx]
	mov	ah,3Ch
	int	21h
	jc	@@0
	mov	[ss:diskh+bx],ax
	test	ah,00h
@@0:	ret
endp
; 
proc	scandsk
@@2:	lodsb
	cmp	al,ah
	jz	@@1
	cmp	si,offset sectbuf+6300
	jb	@@2
	stc
@@1:	ret
endp
; 
proc	seekdsk
	mov	bx,ax
seek1:	movzx	dx,[@fdc3f]
	shl	dx,1
	mov	al,[@fdcff]
	shr	al,4
	xor	al,1
	and	al,1
	or	dl,al
	shl	dx,4
	mov	al,[@fdc5f]
	inc	ch
	jz	@@1
	mov	al,ch
@@1:	dec	al
	test	al,0F0h
	jnz	@@0
	or	dl,al
	movzx	cx,dh
	shl	dx,8
	mov	ax,4200h
	int	21h
	ret
;	
@@0:	stc
	ret
;	
;@seek1:		
endp
; 
include	"zx-keyb.asi"
include	"emul_r.asi"
; 
oldpic	db	?
align	4
intpts:
IRP	x,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32;,33
	dw	int&x
ENDM
irqpts:
IRP	x,0,1,2,3,4,5,6,7
	dw	irq&x
ENDM

picmask	db	0FCh
mousbtn	db	0
oldtr	db	0
align	2
mousmx	db	100
mousmy	db	-100
mousx	dw	0
mousy	dw	0
mouscmd	db	0,0,0,0
mousbuf	dw	mouscmd
lpport	dw	378h
grey	db	0
kflg	db	2
curprot	db	0
disk1	db	'default.trd',244 dup (0)
disk2	db	'default.trd',244 dup (0)
disk3	db	'default.trd',244 dup (0)
disk4	db	'default.trd',244 dup (0)
align	4
fdprts	dw	10 dup (0)
timcou	dw	0
curh	dw	-1
pags	dw	2 dup (80h,88h,90h,98h,0A0h,0A8h,0B0h,0B8h)
	dw	2 dup (40h,48h,50h,58h,60h,68h,70h,78h)
	dw	2 dup (80h,88h,90h,98h,0A0h,0A8h,0B0h,0B8h)
	dw	2 dup (40h,48h,50h,58h,60h,68h,70h,78h)
vpags	dw	8 dup (-1,-1,-1,-1,-1,0,-1,3000h)
vhpg	dw	4 dup (8 dup (VPAGE1 SHR 9),8 dup (VPAGE2 SHR 9))
fsysr	dw	32 dup (_SY128),32 dup (_NUL)
rompts	dw	emudata,0,emu128,0,emu128,400h
rampts	dw	emudata,0C00h,emu128,800h,emudata,800h,emu128,0C00h
	dw	emu128,01000h,emudata,400h,emu128,1400h,emu128,1800h
promap	dw	32 dup (_NUL)
	dw	32 dup (_NUL)
	dw	32 dup (_NUL)
	dw	32 dup (_NUL)
	dw	32 dup (_NUL)
	dw	32 dup (_NUL)
	dw	32 dup (_NUL)
	dw	27 dup (_NUL),_LPOUT,_NUL,_AYS0,_BRD,_NUL
primap	dw	32 dup (_INFF)
	dw	32 dup (_INFF)
	dw	32 dup (_INFF)
	dw	32 dup (_INFF)
	dw	32 dup (_INFF)
	dw	32 dup (_INFF)
	dw	31 dup (_INFF),_KMM
	dw	27 dup (_INFF),_LPIN,_INFF,_AYIS,_KEYB,_INFF
fdccmds	dw	16 dup (_FDPOS0)				; 0000HVRR
	dw	16 dup (_FDSEEK)				; 0001HVRR
	dw	16 dup (_FDSTEP),16 dup (_FDSTEP1)		; 001THVRR
	dw	16 dup (_FDSTF),16 dup (_FDSTF1)		; 010THVRR
	dw	16 dup (_FDSTB),16 dup (_FDSTB1)		; 011THVRR
	dw	32 dup (_FDRDS)					; 100MSECA
	dw	32 dup (_FDWRS)					; 101MSECA
	dw	2 dup (_FDRDA,3 dup (_FDNUL)),8 dup (_FDNUL)	; 11000E00
	dw	16 dup (_FDHLT)					; 1101IIII
	dw	2 dup (_FDRDT,3 dup (_FDNUL)),8 dup (_FDNUL)	; 11100E00
	dw	2 dup (_FDWRT,3 dup (_FDNUL)),8 dup (_FDNUL)	; 11110E00
musvol	db	63,55,49,44,40,36,32,28,24,20,16,12,8,5,2,0
nsvol	db	63,60,56,53,49,46,42,39,35,32,28,25,21,18,14,11
new_st	dw	?,20h
old_st	dw	?,?
oldcr0	dd	?
exstat	dw	?
rm	dw	?
regs	dw	80h dup (?)
sectbuf	db	6300 dup (0)
public	sectbuf
public	fdopen
public	fdseek
public	rdaddr
public	rdsect
public	wrsect
public	pags
public	vpags
public 	vhpg
public	fsysr
public	promap
public	primap
public	fdccmds
public	irq1
public	musvol
public	nsvol
public	mousx
public	mousy
public	mousbtn
public	lpport
ends
end
