ideal
P186
model	tiny
include	"zx-const.asi"
include	"z80regs.asi"
codeseg
public	debug
public	debug1
public	@debmode

extrn	vgmtext:near
extrn	vgmon:near
extrn	dis80:near
extrn	dis80str:near

KEYONINT9=1
CLEARSCR=0

@debmode = byte ss:DEBUGAREA
@curctls = word ss:DEBUGAREA+2
@debmem1 = word ss:DEBUGAREA+4
@debmem2 = word ss:DEBUGAREA+6
@step_sp = word ss:DEBUGAREA+8
@go_brk	= word ss:DEBUGAREA+10


proc	debug	far
	
;	mov	[@curctls],offset ctls
;	mov	[@debmem1],0
;	mov	[@debmode],1
;	push	cs
;	call	goctls
;	ret

	jmp	[word ss:12h]
;   맮 
debug1:	pushf

	shl	[@iff],1
	and	[@iff],0FBh
	
	call	vgmtext
@db1:	pusha
	
	enter	60,0
	mov	[bp-8],si		;   DISASM'
	mov	[bp-52],si		; PC
	
;	mov	[word ss:12h],offset debug2
	mov	[byte ss:0Dh],0		; ⪠ 
	mov	[@curctls],offset ctls
	mov	[@debmode],1
	xor	di,di

@@de0:	call	goctls
	cmp	al,3Fh;1
	jnz	@@de4

	call	@vgmon1
	leave
	
	jmp	@@de98
;	 F1 
@@de4:	cmp	al,3Bh
	jnz	@@de1
	mov	[word ss:12h],offset debug3
	leave
	popa
	jmp	@@de5
;	 F2 
@@de1:	cmp	al,3Ch
	jnz	@@de8
	call	@curs3
	mov	[word ss:12h],offset debug4
	leave
	mov	bx,[@sp]
	mov	[@step_sp],bx
	popa
	jmp	@@de5
;	 F3 
@@de8:	cmp	al,3Dh
	jnz	@@de9
	call	@curs3
	mov	[word ss:12h],offset debug5
	leave
	popa
	jmp	@@de5;@@de5
;	 F4 
@@de9:	cmp	al,3Eh
	jnz	@@de10
;	 F5 
@@de10:	cmp	al,3Fh
	jnz	@@de11
;	 F6 
@@de11:	cmp	al,40h
	jnz	@@de0
	call	@vgmon1
	call	@getscan
	call	vgmtext
	jmp	@@de0
;	
@@de12:
@@de13:
@@de14:
@@de15:
@@de16:
@@de17:
@@de99:	leave
@@de98:	popa
	mov	[word ss:12h],offset debug1
	mov	dx,8
	cmp	[@halt],0
	jz	@@de2
	mov	dx,3
@@de2:	mov	[@cycle],dx
@@de6:	
@@de5:	
	shr	[@iff],1
	popf
	ret
;  ⨢ 	
debug2:	
	ret
;  Step 	
debug3:	pushf
	shl	[@iff],1
	and	[@iff],0FBh
	jmp	@db1
;  ProcStep 	
debug4:	pushf
	mov	bx,[@sp]
	cmp	bx,[@step_sp]
	jb	@@db4

	shl	[@iff],1
	and	[@iff],0FBh
	jmp	@db1
	
@@db4:	popf
	ret
; 	
debug5:	pushf
	cmp	si,[@go_brk]
	jnz	@@db5
	shl	[@iff],1
	and	[@iff],0FBh
	jmp	@db1
	
@@db5:	popf
	ret
; 	

endp
;
proc	@vgmon1
	push	bp
	call	vgmon
	mov	bp,[bp]
	mov	dx,3DAh
	in	al,dx
	mov	dx,3C0h
	mov	al,31h
	out	dx,al
	mov	al,[@brd]
	out	dx,al
	pop	bp
	ret
endp
;
proc	@inkey
IF KEYONINT9
	mov	al,[ss:0Dh]
	and	al,al
	mov	al,[ss:0Ch]
ELSE
	mov	ah,1
	int	16h
	mov	al,ah
ENDIF
	ret
endp
proc	@getscan
IF KEYONINT9
@@0:	mov	al,[ss:0Dh]
	dec	al
	jz	@@1
	hlt
	jmp	@@0
;	
@@1:	mov	[ss:0Dh],al
	mov	al,[ss:0Ch]
	test	al,80h
	jnz	@@0
ELSE
	mov	ah,0
	int	16h
	mov	al,ah
ENDIF
	ret
endp
;
proc	goctls
	cld
	push	di
IF CLEARSCR
	xor	di,di
	mov	ax,700h
	mov	cx,4000
	rep	stosw
	pop	di
ENDIF
	mov	[word bp-14],0
	call	scrupd
	pop	di
	mov	si,[@curctls]
@@2:	segcs
	lodsw
	inc	ax
	jnz	@@0
	ret
;	
@@0:	segcs
	lodsw
	mov	cl,[@debmode]
	shr	ax,cl
	jnc	@@3
	segcs
	lodsb
	and	al,al
	jnz	@@1
	dec	si
@@3:	add	si,6
	jmp	@@2
;	
@@1:	and	di,di
	jnz	@@b
	lea	di,[si-5]
@@b:	mov	bx,[cs:di]
	call	@setcurs
	call	@curs1
@@4a:	call	@getscan
	
	cmp	al,3Fh;1
	jnz	@@4
	ret
;	
@@4:	mov	bx,[cs:di+4]
	and	bx,7
	add	bx,bx
	push	si
	call	[cs:@@evcts+bx]
	pop	si
	and	al,al
	jnz	@@4b
	push	di
	call	scrupd
	pop	di
	jmp	@@4a
;	
@@4b:	mov	[word bp-14],0

	cmp	al,4Bh
	jnz	@@5
	mov	[word bp-4],offset @xm1
	call	@enum
	jmp	@@b
;	
@@5:	cmp	al,4Dh
	jnz	@@6
	mov	[word bp-4],offset @xp1
	call	@enum
	jmp	@@b
;	
@@6:	cmp	al,48h
	jnz	@@7
	mov	[word bp-4],offset @ym1
	call	@enum
	jmp	@@b
;	
@@7:	cmp	al,50h
	jnz	@@8
	mov	[word bp-4],offset @yp1
	call	@enum
	jmp	@@b
;	
@@8:

;	jmp	@@b
	ret
;	
align	2	
@@evcts	dw	@@nul,@@nul,@hmc,@@nul,@@nul,@disc,@@nul,@@nul
;	
@@nul:	ret
;	
endp
;	
proc	@disc
	cmp	al,48h
	jnz	@@1
	dec	[word bp-8]
	xor	al,al
	ret
@@1:	cmp	al,50h
	jnz	@@2
	mov	ax,[word bp-16]
	mov	[bp-8],ax
	xor	al,al
	ret
@@2:	cmp	al,49h
	jz	@@4
	cmp	al,51h
	jnz	@@5
@@4:	dec	al
	ret
@@5:	cmp	al,3Dh
	jnz	@@3
	mov	dx,[bp-8]
	mov	[@go_brk],dx
@@3:	ret
endp
;	
proc	@hmc
	mov	si,[cs:di+6]
	
	cmp	al,0Eh
	jnz	@@3
	mov	al,[bp-14]
	dec	al
	jmp	@@5
;	
@@3:;	cmp	al,4Dh
;	jz	@@4
	call	@inhex
	cmp	ah,1
	jz	@@1
	mov	bl,[bp-14]
	not	bl
	and	bx,3
	mov	al,0Fh
	shr	bl,1
	jnc	@@2
	mov	al,0F0h
@@2:	and	ah,al
	not	al
	and	al,[ss:si+bx]
	or	al,ah
	mov	[ss:si+bx],al
@@4:	mov	al,[bp-14]
	inc	al
@@5:	and	[byte bp-14],0FCh
	and	al,3
	or	[bp-14],al
	mov	bx,[cs:di]
	add	bl,al
	add	bl,al
	call	@setcurs
	
	xor	al,al
@@1:	ret
endp
;	
proc	@inhex
	mov	ah,1
	cmp	al,31h
	jae	@@1
	mov	bx,offset @@htbl
	mov	ah,al
	segcs
	xlat
	xchg	al,ah
@@1:	ret
@@htbl	db	1,1,11h,22h,33h,44h,55h,66h,77h,88h,99h,00h,1,1,1,1
	db	1,1,0EEh,1,1,1,1,1,1,1,1,1,1,1,0AAh,1
	db	0DDh,0FFh,1,1,1,1,1,1,1,1,1,1,1,1,0CCh,1
	db	0BBh
endp
; 
proc	@xp1
	cmp	ah,ch
	jbe	@@2
	sub	al,cl
	jns	@@1
	neg	al
@@1:	mov	bl,ah
	mov	bh,0
	mul	dl
	add	ax,bx
	cmp	ax,[bp-2]
	cmc
	ret
@@2:	stc
	ret
endp
; 
proc	@xm1
	cmp	ah,ch
	jae	@@2
	sub	al,cl
	jns	@@1
	neg	al
@@1:	mov	bl,160
	sub	bl,ah
	mov	bh,0
	mul	dl
	add	ax,bx
	cmp	ax,[bp-2]
	cmc
	ret
@@2:	stc
	ret
endp
; 
proc	@yp1
	cmp	al,cl
	jbe	@@2
	sub	ah,ch
	jns	@@1
	neg	ah
@@1:	mov	bl,al
	mov	bh,0
	mov	al,ah
	mul	dl
	add	ax,bx
	cmp	ax,[bp-2]
	cmc
	ret
@@2:	stc
	ret
endp
; 
proc	@ym1
	cmp	al,cl
	jae	@@2
	sub	ah,ch
	jns	@@1
	neg	ah
@@1:	mov	bl,160
	sub	bl,al
	mov	bh,0
	mov	al,ah
	mul	dl
	add	ax,bx
	cmp	ax,[bp-2]
	cmc
	ret
@@2:	stc
	ret
endp
; 
proc	@enum
	mov	dl,160
	mov	si,[@curctls]
	mov	[word bp-2],-1
	mov	cx,[bp-6]
@@ea:	mov	ax,[cs:si]
	inc	ax
	jnz	@@ee
	ret
;	
@@ee:	dec	ax
	push	ax
	mov	ax,[cs:si+2]
	push	cx
	mov	cl,[@debmode]
	shr	ax,cl
	pop	cx ax
	jnc	@@eb
	cmp	[byte cs:si+4],0
	jz	@@eb
	div	dl
	push	bx
	call	[word bp-4]
	pop	bx
	jc	@@eb
	mov	[bp-2],ax
	mov	di,si
@@eb:	add	si,10
	jmp	@@ea
endp
;
proc	@curs1
	mov	dx,3D4h
	mov	al,9
	out	dx,al
	inc	dx
	in	al,dx
	and	al,1Fh
	dec	al
	mov	ah,al
	dec	dx
	mov	al,11
	out	dx,ax
	mov	ax,10
	out	dx,ax
	ret
endp
;
proc	@curs2
	mov	dx,3D4h
	mov	al,9
	out	dx,al
	inc	dx
	in	al,dx
	and	al,1Fh
	dec	al
	mov	ah,al
	dec	dx
	mov	al,11
	out	dx,ax
	mov	al,10
	dec	ah
	out	dx,ax
	ret
endp
;
proc	@curs3
	mov	dx,3D4h
	mov	al,9
	out	dx,al
	inc	dx
	in	al,dx
	and	al,1Fh
	shr	al,1
	mov	ah,al
	dec	dx
	mov	al,11
	out	dx,ax
	mov	al,10
	out	dx,ax
	ret
endp
;
proc	@setcurs
	mov	dl,160
	mov	ax,bx
	div	dl
	mov	[bp-6],ax

	shr	bx,1
	mov	dx,3D4h
	mov	al,14
	mov	ah,bh
	out	dx,ax
	inc	al
	mov	ah,bl
	out	dx,ax
	shl	bx,1
	ret
endp
;
proc	scrupd
	cld
	mov	si,[@curctls]
@@0:	segcs
	lodsw
	inc	ax
	jnz	@@2
	ret
;		
@@2:	dec	ax
	mov	di,ax
	segcs
	lodsw
	mov	cl,[@debmode]
	shr	ax,cl
	jc	@@1
	add	si,6
	jmp	@@0
;	
@@1:	segcs
	lodsw
	mov	ch,ah
	and	ax,7
	add	ax,ax
	mov	bx,ax
	mov	dx,[cs:@ctltyps+bx]
	segcs
	lodsw
	mov	bx,ax
	segcs
	lodsw
	push	si
	call	dx
	pop	si
	jmp	@@0
;	
@@hm:	mov	dx,[@debmem1]
	mov	[bp-12],ax
	and	[byte bp-11],3Fh
	test	ah,80h
	jz	@@m1
	mov	dx,[@debmem2]
@@m1:	add	bx,dx
	mov	cl,al
	test	ah,40h
	jz	@@m2
@@m3:	mov	al,[bx]
	inc	bx
	mov	ah,ch
	stosw
	dec	cl
	jnz	@@m3
	ret

@@m2:	push	di
@@m2a:	mov	al,[bx]
	inc	bx
	call	@@h2x
	mov	ax,0720h
	stosw
	dec	cl
	jnz	@@m2a
	pop	di
	add	di,160
	mov	cl,[bp-12]
	dec	[byte bp-11]
	jnz	@@m2
	ret
;	
@@h4:	mov	ax,[ss:bx]
@@h4x:	push	ax
	mov	al,ah
	call	@@h2x
	pop	ax
	jmp	@@h2x
;	
@@h2:	mov	al,[ss:bx]
@@h2x:	aam	16
	xchg	al,ah
	call	@@h1
	xchg	al,ah
@@h1:	add	al,90h
	daa
	adc	al,40h
	daa
	stosb
	mov	al,ch
	stosb
	ret
;	
@@tx:	mov	si,bx
	test	ah,80h
	mov	ah,ch
	jnz	@@t2
@@t0:	segcs
	lodsb
	and	al,al
	jz	@@t1
	stosw
	jmp	@@t0
@@t1:	ret
;	
@@t2:	segss
	lodsb
	and	al,al
	jz	@@t1
	stosw
	jmp	@@t2
;	
@@rg:	mov	si,[bp]
	test	ah,80h
	mov	ax,[ss:si+bx]
	jz	@@h2x
	jmp	@@h4x
;	
@@dis:	mov	si,[bp-8]
	mov	[bp-10],si
	mov	[word bp-12],ax
	mov	[byte bp-17],0
@@d3:	push	di
	lea	di,[bp-50]
	mov	si,[bp-10]
	call	dis80str
	mov	[bp-10],si
	cmp	[byte bp-17],0
	mov	[byte bp-17],1
	jnz	@@d6
	mov	[bp-16],si
@@d6:	mov	ah,ch
	mov	si,di
	pop	di
	push	di
	mov	cl,[bp-12]
@@d2:	segss
	lodsb
	and	al,al
	jz	@@d4
	stosw
	dec	cl
	jnz	@@d2
	jmp	@@d1
;	
@@d4:	mov	al,20h
@@d5:	stosw
	dec	cl
	jnz	@@d5
@@d1:	pop	di
	add	di,160
	dec	[byte bp-11]
	jnz	@@d3
	ret
;	
;	
@ctltyps dw	@@tx,@@h2,@@h4,@@hm,@@rg,@@dis,@@t1,@@t1
endp
; 
COL=700h
macro	@color	c
COL=(c SHL 8)
endm
;	
macro	@text	y,x,p,a
	local	@@txt
	dw	y*160+x*2,p,COL,@@txt,0
dataseg
@@txt	db	a,0
codeseg
endm
;	
macro	@textp	y,x,p,a
	local	@@txt
	dw	y*160+x*2,p,COL,a,0
endm
;	
macro	@hexb	y,x,p,a
	dw	y*160+x*2,p,COL+1h,a,0
endm
;	
macro	@hexw	y,x,p,a
	dw	y*160+x*2,p,COL+2h,a,0
endm
;	
macro	@hexm1	y,x,p,a,c,r
IFB	<r>
	dw	y*160+x*2,p,COL+3h,a,c+100h
ELSE
	dw	y*160+x*2,p,COL+3h,a,c+r*256
ENDIF
endm
;	
macro	@hexm2	y,x,p,a,c,r
IFB	<r>
	dw	y*160+x*2,p,COL+3h,a,c+8100h
ELSE
	dw	y*160+x*2,p,COL+3h,a,c+r*256+8000h
ENDIF
endm
;	
macro	@ascm1	y,x,p,a,c
	dw	y*160+x*2,p,COL+3h,a,c+4100h
endm
;	
macro	@ascm2	y,x,p,a,c
	dw	y*160+x*2,p,COL+3h,a,c+0C100h
endm
;	
macro	@reg8	y,x,p,a
	dw	y*160+x*2,p,COL+4h,a,0
endm
;	
macro	@reg16	y,x,p,a
	dw	y*160+x*2,p,COL+4h,a,8000h
endm
;	
macro	@disa	y,x,p,h,w
	dw	y*160+x*2,p,COL+5h,0,h*256+w
endm
; 
;    . :
; x,y - ࠭ न
; p   -  ⢨
;
;  @color c                   - ⥪騩 ਡ c
;  @text  y,x,p,text          - 䨪஢ ⥪ asciiz 
;  @textp y,x,p,addr          - ⥪   ss:addr
;  @hexb  y,x,p,addr          - hex-   ss:addr
;  @hexw  y,x,p,addr          - hex-᫮   ss:addr
;  @hexm1 y,x,p,ind,col[,row] -   hex- [ds:@debmem1+ind] col , row ப
;  @ascm1 y,x,p,ind,col       -   ascii- [ds:@debmem1+ind] col 
;  @reg8  y,x,p,addr          - byte   [ss:bp+addr] ()
;  @reg16 y,x,p,addr          - word   [ss:bp+addr] ()

ctls:
	@color	7
	@disa	5,0,1,10,30
	@hexm1	5,39,1,0,8,10
	@color	7
	@text	0,0,1,' A='
	@text	1,0,1,'BC='
	@text	1,8,1,'DE='
	@text	1,16,1,'HL='
	@text	2,0,1,'BC'''
	@text	2,8,1,'DE'''
	@text	2,16,1,'HL'''
	@text	0,24,1,'AF'''
	@text	1,24,1,'IX='
	@text	2,24,1,'IY='
	@text	3,0,1,'SP='
	@text	3,13,1,'Break='
	@color	0Bh
	@reg8	0,3,1,1
	@reg16	1,3,1,4
	@reg16	1,11,1,8
	@reg16	1,19,1,12
	@reg16	2,3,1,6
	@reg16	2,11,1,10
	@reg16	2,19,1,14
	@reg16	0,27,1,2
	@reg16	1,27,1,18
	@reg16	2,27,1,20
	@reg16	3,3,1,16
	
	@hexw	5,34,1,<offset @debmem1>
	@hexw	3,19,1,<offset @go_brk>
	
;	@hexb	0,9,1,1
;	@hexb	1,6,1,2
;	@hexb	1,9,1,3
;	@ascm1	2,7,1,0,10h
;	@reg8	4,10,1,4
	
	dw	-1
end