ideal
;     ᥬ Z-80
; Copyright (c) Programmist X
;
; Input: DS:SI -> command
;        SS:DI -> output buffer
; Output: output buffer filled (ASCIIZ)
;        SI -> next command
;
public	dis80str
public	dis80
;
; ⫨稥  㭪権 -  ଠ 室 .
; ਬ: 
;   SI=0742, DS:SI -> 21 15 9A ED B0
;  ᫥ dis80:    SS:DI -> 'ld   hl,#9A15'
;  ᫥ dis80str: SS:DI -> '0742 21159A   ld   hl,#9A15'
;   砥 DS:SI ⠭  ᫥ . 
; ⠫ ॣ  
p186
jumps
model	tiny
macro	_hex	t,n
	d&t	0&n&h
endm
macro	hexw	hs
	irp	q,hs
	_hex	w,q
	endm
endm
macro	hex	hs
	irp	q,hs
	_hex	b,q
	endm
endm
codeseg
; 
proc	dis80str
	cld
	push	di ax bx cx
	mov	bx,si
	call	@pw2
	mov	cx,10
@@1:	mov	[byte ss:di],' '
	inc	di
	loop	@@1
	pop	cx
	push	si
	call	dis80
	sub	di,9
	pop	ax
	push	cx si
	mov	cx,si
	mov	si,ax
	sub	cx,si
	cmp	cx,5
	jb	@@s1
	mov	cl,4
	mov	[byte ss:di+8],10h
@@s1:	lodsb
	call	@pb
	loop	@@s1
	pop	si cx bx ax di
	ret
endp
; 
proc	dis80
	cld
	push	ax bx cx dx di bp
	mov	bp,sp
	push	bp
	xor	ch,ch
@@e2:	lodsb
	mov	cl,al
	mov	bx,offset ditbl1
	cmp	al,0DDh
	jnz	@@e1
	and	ch,0F7h
	or	ch,4
	jmp	@@e2
;	
@@e1:	cmp	al,0FDh
	jnz	@@e3
	and	ch,0FBh
	or	ch,8
	jmp	@@e2
;	
@@e3:	cmp	al,0EDh
	jnz	@@d2
	lodsb
	mov	ch,1
	cmp	al,40h
	jb	@@d5
	cmp	al,0C0h
	jae	@@d5
	mov	cl,al
	mov	bx,offset ditbl2-40h*2
	jmp	@@dix
;	
@@d5:	xor	dx,dx
	jmp	@@d6
;	
@@d2:	cmp	al,0CBh
	jnz	@@d7
	test	ch,0Ch
	jz	@@d11
	lodsb
	mov	[bp-2],al
	or	ch,10h
@@d11:	lodsb
	mov	cl,al
	shr	al,3
	mov	bx,offset ditbl3
	jmp	@@dix
;	
@@d7:
@@dix:	mov	ah,0
	shl	ax,1
	add	bx,ax
	mov	dx,[cs:bx]
@@d6:	mov	bl,dl
	and	bx,7Fh
	shl	bx,2
	mov	ax,[word cs:mne0+bx]
	mov	[ss:di],ax
	inc	di
	inc	di
	mov	ax,[word cs:mne0+bx+2]
	mov	[ss:di],ax
	inc	di
	inc	di
	test	ch,0Ch
	jz	@@d9
	test	dl,80h
	jz	@@d9
	lodsb
	mov	[bp-2],al
@@d9:	mov	bl,dh
	and	bx,0Fh
	jz	@@d3
	mov	[byte ss:di],' '
	inc	di	
	shl	bx,1
	call	[word cs:arg1+bx]
	mov	bl,dh
	shr	bl,3
	and	bx,1Eh
	jz	@@d3
	mov	[byte ss:di],','
	inc	di
	call	[word cs:arg2+bx]
@@d3:	test	ch,10h
	jz	@@d12
	mov	al,cl
	and	al,0C0h
	cmp	al,40h
	jz	@@d12
	mov	al,cl
	and	al,7
	cmp	al,6
	jz	@@d12
	mov	[byte ss:di],','
	inc	di
	call	@indx
@@d12:	mov	[byte ss:di],0
	inc	di
	jmp	@@d0
;		
@@d1:
@@d0:	mov	sp,bp
	pop	bp di dx cx bx ax
	ret
; 
@rhl:	test	ch,0Ch
	jnz	@@r1
	mov	[word ss:di],'lh'
	inc	di
	inc	di
	ret

@@r1:	mov	ax,'yi'
	test	ch,4
	jz	@@r2
	mov	ax,'xi'
@@r2:	mov	[ss:di],ax
	inc	di
	inc	di
	ret
; 
@indx:	test	ch,0Ch
	jnz	@@i1
	and	ch,ch
	jnz	@@i2
	mov	[word ss:di],'h('
	inc	di
	inc	di
	mov	[word ss:di],')l'
	inc	di
	inc	di
	ret
;	
@@i2:	mov	[word ss:di],'f'
	inc	di
	ret
;	
@@i1:	mov	[word ss:di],'i('
	inc	di
	inc	di
	mov	al,'y'
	test	ch,4
	jz	@@i3
	mov	al,'x'
@@i3:	mov	[ss:di],al
	inc	di
	mov	al,'+'
	mov	ah,[bp-2]
	and	ah,ah
	jns	@@i4
	mov	al,'-'
	neg	ah
@@i4:	mov	[ss:di],al
	inc	di
	mov	[byte ss:di],'#'
	inc	di
	mov	al,ah
	call	@pb
	mov	[byte ss:di],')'
	inc	di
	ret
;	
@A0:	ret				; 
;	
@A2:	mov	bl,cl			; .  (5,4)
	shr	bl,3
	and	bx,6
	add	bx,offset @reg2
	mov	ax,[cs:bx]
	cmp	al,'h'
	jz	@rhl
	mov	[ss:di],ax
	inc	di
	inc	di
	ret
;	
@A3:	mov	[byte ss:di],'('	; .  ᪮ (5,4)
	inc	di	
	call	@A2
	mov	[byte ss:di],')'
	inc	di	
	ret
;	
@A4:	lodsb				; ⭮⥫쭮 ᬥ饭
	cbw
	add	ax,si
@pw:	mov	bx,ax
	mov	[byte ss:di],'#'
	inc	di	
@pw2:	mov	al,bh
	call	@pb
	mov	al,bl
@pb:	aam	16
	xchg	al,ah
	call	@pn
	mov	al,ah
@pn:	add	al,90h
	daa
	adc	al,40h
	daa
	mov	[ss:di],al
	inc	di
	ret
;	
@A5:	mov	[byte ss:di],'('	; ⠭ (word)  ᪮
	inc	di	
	lodsw
	call	@pw
	mov	[byte ss:di],')'
	inc	di	
	ret
;	
@A6:	mov	bl,cl			; ᫮
	shr	bl,2
	test	bl,20h
	jnz	@@a6
	and	bl,0F7h
@@a6:	and	bl,0Eh
	mov	bh,0
	add	bx,offset @cnd1
	mov	ax,[cs:bx]
	mov	[ss:di],al
	inc	di
	cmp	ah,' '
	jz	@@a6a
	mov	[ss:di],ah
	inc	di
@@a6a:	ret
;	
@A7:	mov	al,cl			;  (2,1,0)
	jmp	@a1a
;	
@A8:	mov	[byte ss:di],'#'	; ⠭ (5,4,3)
	inc	di	
	mov	al,cl
	and	al,38h
	jmp	@pb
;	
@A9:	mov	[byte ss:di],'#'	; ⠭ ()
	inc	di	
	lodsb
	jmp	@pb
;	
@AA:	mov	al,cl			; ⠭ (5,4,3)
	shr	al,3
	and	al,7
	add	al,'0'
	mov	[ss:di],al
	inc	di
	ret
;	
@AB:	mov	[byte ss:di],'a'	;  a
	inc	di	
	ret
;	
@AC:	jmp	@rhl			;  hl
;	
@AD:
@AE:
	ret
;	
@AF:	cmp	cl,08h			; ᮡ 砩
	jnz	@@f10
	mov	[word ss:di],'fa'
	inc	di
	inc	di
	ret
;	
@@f10:	cmp	cl,47h
	jnz	@@f11
	mov	[byte ss:di],'i'
	inc	di
	ret
;	
@@f11:	cmp	cl,4Fh
	jnz	@@f12
	mov	[byte ss:di],'r'
	inc	di
	ret
;	
@@f12:	mov	al,cl
	and	al,0C7h
	cmp	al,41h
	jnz	@@f13
@bfc:	mov	[word ss:di],'c('
	inc	di
	inc	di
	mov	[byte ss:di],')'
	inc	di
	ret
;	
@@f13:	cmp	al,42h
	jnz	@@f1
	mov	[word ss:di],'lh'
	inc	di
	inc	di
	ret
;	
@@f1:	cmp	cl,0C3h
	jz	@B2
	cmp	cl,0CDh
	jnz	@@f3
@B2:	lodsw
	jmp	@pw
;	
@@f3:	cmp	cl,0D3h
	jnz	@@f4
@bfa:	mov	[word ss:di],'#('
	inc	di
	inc	di
	lodsb
	call	@pb
	mov	[byte ss:di],')'
	inc	di
	ret
;	
@@f4:	cmp	cl,0E3h
	jnz	@@f5
	mov	[word ss:di],'s('
	inc	di
	inc	di
	mov	[word ss:di],')p'
	inc	di
	inc	di
	ret
;	
@@f5:	cmp	cl,0E9h
	jnz	@@f6
	mov	[byte ss:di],'('
	inc	di
	call	@rhl
	mov	[byte ss:di],')'
	inc	di
	ret
;	
@@f6:	cmp	cl,0EBh
	jnz	@@f7
	mov	[word ss:di],'ed'
	inc	di
	inc	di
	ret
;	
@@f7:	cmp	cl,0F5h
	ja	@@f8
	mov	[word ss:di],'fa'
	inc	di
	inc	di
	ret
;	
@@f8:	cmp	cl,0F9h
	jnz	@@f9
	mov	[word ss:di],'ps'
	inc	di
	inc	di
@@f9:	ret
; 
@B0:	ret
;	
@BA:
@BB:
@BC:
@BD:
@BE:
	ret
; 
@BF:	cmp	cl,08h			; ᮡ 砩
	jnz	@@b1
	mov	[word ss:di],'fa'
	inc	di
	inc	di
	mov	[byte ss:di],"'"
	inc	di
	ret
;	
@@b1:	cmp	cl,0DBh
	jz	@bfa
	cmp	cl,57h
	jnz	@@b2
	mov	[byte ss:di],'i'
	inc	di
	ret
;	
@@b2:	cmp	cl,5Fh
	jnz	@@b3
	mov	[byte ss:di],'r'
	inc	di
	ret
;	
@@b3:	mov	al,cl
	and	al,0C7h
	cmp	al,40h
	jnz	@@b4
	jmp	@bfc
;	
@@b4:	cmp	al,41h
	jnz	@@b5
	jmp	@A1
;	
@@b5:	cmp	cl,0EBh
	jnz	@@b6
	mov	[word ss:di],'lh'
	inc	di
	inc	di
	ret
;	
@@b6:
	ret
;	
@A1:	mov	al,cl			;  (5,4,3)
	shr	al,3
@a1a:	and	al,7
	mov	bx,offset @reg1
	segcs
	xlat
	cmp	al,'m'
	jnz	@@a1
	jmp	@indx
@@a1:	mov	[ss:di],al
	inc	di
	cmp	al,'h'
	jz	@@a1b
	cmp	al,'l'
	jnz	@@a1c
@@a1b:	test	ch,0Ch
	jz	@@a1c
	test	dl,80h
	jnz	@@a1c
	mov	al,'y'
	test	ch,4
	jz	@@a1d
	mov	al,'x'
@@a1d:	mov	[ss:di],al
	inc	di
@@a1c:	ret



; 
@index	db	0
@reg1	db	'bcdehlma'
@reg2	db	'bcdehlsp'
@cnd1	db	'nzz ncc popep m '
align	2
arg1	dw	@A0,@A1,@A2,@A3,@A4,@A5,@A6,@A7,@A8,@A9,@AA,@AB,@AC,@AD,@AE,@AF
arg2	dw	@B0,@A7,@B2,@A9,@A2,@A5,@A4,@AB,@A3,@AC,@BA,@BB,@BC,@BD,@BE,@BF
;		 0   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F
mne0	db	'??? nop rlcarrcarla rra daa cpl scf ccf ret exx di  ei  neg retn'
	db	'im 0retiim 1rrd im 2rld ldi cpi ini outildd cpd ind outdldircpir'
	db	'inirotirlddrcpdrindrotdrhaltinc dec djnzjr  sub and xor or  cp  '
	db	'pop jp  pushrst callrlc rrc rl  rr  sla sra sli srl ld  ex  add '
	db	'adc sbc out in  bit res set '
ditbl1:	hexw	<001,223D,733D,227,127,128,313D,002,FF3E,4C3F,8B3D,228,127,128,313D,003>
	hexw	<429,223D,733D,227,127,128,313D,004,42A,4C3F,8B3D,228,127,128,313D,005>
	hexw	<662A,223D,953D,227,127,128,313D,006,662A,4C3F,5C3D,228,127,128,313D,007>
	hexw	<662A,223D,753D,227,1A7,1A8,31BD,008,662A,4C3F,5B3D,228,127,128,313D,009>
	hexw	<113D,113D,113D,113D,113D,113D,11BD,113D,113D,113D,113D,113D,113D,113D,11BD,113D>
	hexw	<113D,113D,113D,113D,113D,113D,11BD,113D,113D,113D,113D,113D,113D,113D,11BD,113D>
	hexw	<113D,113D,113D,113D,113D,113D,11BD,113D,113D,113D,113D,113D,113D,113D,11BD,113D>
	hexw	<11BD,11BD,11BD,11BD,11BD,11BD,0026,11BD,113D,113D,113D,113D,113D,113D,11BD,113D>
	hexw	<1B3F,1B3F,1B3F,1B3F,1B3F,1B3F,1BBF,1B3F,1B40,1B40,1B40,1B40,1B40,1B40,1BC0,1B40>
	hexw	<72B,72B,72B,72B,72B,72B,7AB,72B,1B41,1B41,1B41,1B41,1B41,1B41,1BC1,1B41>
	hexw	<72C,72C,72C,72C,72C,72C,7AC,72C,72D,72D,72D,72D,72D,72D,7AD,72D>
	hexw	<72E,72E,72E,72E,72E,72E,7AE,72E,72F,72F,72F,72F,72F,72F,7AF,72F>
	hexw	<60A,230,2631,F31,2634,232,3B3F,833,60A,00A,2631,000,2634,F34,3B40,833>
	hexw	<60A,230,2631,7F42,2634,232,92B,833,60A,00B,2631,FB43,2634,000,3B41,833>
	hexw	<60A,230,2631,9F3E,2634,232,92C,833,60A,F31,2631,FF3E,2634,000,92D,833>
	hexw	<60A,F30,2631,00C,2634,F32,92E,833,60A,9F3D,2631,00D,2634,000,92F,833>
	
ditbl2:	hexw	<F143,FF42,4F41,453D,00E,00F,010,7F3D,F143,FF42,4F40,523D,000,011,000,7F3D>
	hexw	<F143,FF42,4F41,453D,000,000,012,FB3D,F143,FF42,4F40,523D,000,000,014,FB3D>
	hexw	<F143,FF42,4F41,453D,000,000,000,0013,F143,FF42,4F40,523D,000,000,000,015>
	hexw	<F143,0000,4F41,453D,000,000,000,0000,F143,FF42,4F40,523D,000,000,000,000>
	hexw	<000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000>
	hexw	<000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000>
	hexw	<016,017,018,019,000,000,000,000,01A,01B,01C,01D,000,000,000,000>
	hexw	<01E,01F,020,021,000,000,000,000,022,023,024,025,000,000,000,000>

ditbl3:	hexw	<735,736,737,738,739,73A,73B,73C,1A44,1A44,1A44,1A44,1A44,1A44,1A44,1A44>
	hexw	<1A45,1A45,1A45,1A45,1A45,1A45,1A45,1A45,1A46,1A46,1A46,1A46,1A46,1A46,1A46,1A46>
endp
end