ideal
VER	equ '5.0'
nojumps
P186
include	"zx-const.asi"
include	"z80regs.asi"
model	tiny
codeseg
startupcode
BEGIN	=	$-100h
NEWKEY	=	STRTKEY
extrn	FONT:byte
;RM	=	4
macro	text	x
	local	@@m1
	push	ax dx
	call	@@m1
	db	x,'$'
@@m1:	pop	dx
	push	cs
	pop	ds
	mov	ah,9
	int	21h
	pop	dx ax
endm
;	
macro	halt n
 rept n
	jcxz $+2
 endm
endm
;	
macro	key	k
	_PS = $
	org	NEWKEY
	dw	_PS
	db	k,0
	NEWKEY	= $
	org	_PS
endm
;extrn	_undiet:near
; ।  
jumps
	mov	bx,cs
	mov	ax,offset endprg+0Fh
	shr	ax,4
	add	ax,bx
	inc	ah
	dec	ax
	xor	al,al
	mov	[sysseg],ax	;  ⥬ ⠡
	add	ax,200h
	mov	[stkseg],ax	;  ⥪
	add	ax,1000h
	mov	[emucode],ax	;  ப
	add	ax,1000h
	mov	[emudata],ax	;   48K
	add	ax,1000h
	cmp	ax,[2]
	jbe	@@i1
@@i0:	text	'Not enough memory'
	ret
;	
@@i1:	mov	[emu128],ax	;   128K
	add	ax,2000h
	mov	[tapseg],ax	;  -뢮
	add	ax,1000h
	cmp	ax,[2]
	jbe	@@i2
	or	[modes],1
@@i2:	xor	ax,ax
	cli
	mov	ss,[stkseg]
	mov	sp,ax
	push	ax
	sti
	

;	mov	ax,0B800h
;	mov	es,ax
;	mov	bp,0F000h
;	mov	[word ss:12h],offset debug1
;	call	debug
;	ret
	
	
	mov	ax,3800h
	mov	dx,offset country
	int	21h

;	jmp	@@c1
;   ப 
jumps
	cld
	mov	si,81h
@@c0:	lodsb
	cmp	al,13
	jz	@@c1
	cmp	al,' '
	jz	@@c0
	cmp	al,'-'
	jnz	@@c0

	mov	di,offset cmdkeys
@@c6:	mov	cx,[di]
	inc	cx
	jz	@@c0
	inc	di
	inc	di
	dec	cx
	push	si
@@c4:	lodsb
	call	toupper
	cmp	al,[di]
	jnz	@@c3
	inc	di
	cmp	[byte di],0
	jnz	@@c4
	call	cx
	pop	cx
	jmp	@@c0
;	
@@c5:	inc	di
	pop	si
	jmp	@@c6
;	
@@c3:	cmp	[byte di],0
	jz	@@c5
	inc	di
	jmp	@@c3
;	
@@c1:
nojumps
; 䨪  
	;int	3
	test	[hard],4
	jnz	@@v1
	mov	ah,12h
	mov	bx,5510h
	int	10h
	cmp	bx,5510h
	jnz	@@v2
	text	<13,10,'Fatal: EGA/VGA not found.',7,13,10>
	mov	ax,4c01h
	int	21h
;	
@@v2:	;int	3
	mov	ax,1200h
	mov	bl,31h
	int	10h
	xor	al,0EDh
	mov	ah,0
	inc	ax
	or	[hard],ah
	push	cs
	pop	es
@@v1:	and	[hard],0fbh
; 㧪 ૥ 

	mov	dx,offset cpu
	mov	ax,3d00h
	int	21h
	jnc	@@m1
	text	<13,10,'Cannot open overlay file',13,10>
	mov	ax,4c01h
	int	21h
;	
@@m1:	mov	bx,ax
	mov	dx,0
	mov	ds,[cs:emucode]
	mov	cx,8000h
	mov	ah,3Fh
	int	21h
	mov	dx,cx
	mov	ah,3Fh
	int	21h
extrn	debug:far
extrn	debug1:near

	mov	[word D_OFFS+1],offset debug
	
	mov	ds,[cs:stkseg]
	xor	dx,dx
	mov	ah,3Fh
	int	21h
	mov	ah,3Eh
	int	21h

	mov	al,[cs:hard2]
	mov	[20h],al

	push	cs
	pop	ds

;	mov	ax,4200h
;	xor	cx,cx
;	mov	dx,0dh
;	int	21h
;	mov	ax,2048
;	push	ax
;	mov	ax,offset inbuf
;	push	cs ax
;	xor	ax,ax
;	push	[cs:emucode] ax
;	push	bx cs
;	call	_undiet
;	add	sp,12
;	mov	ah,3eh
;	int	21h

	mov	dx,[rom]
	mov	ax,3d00h
	int	21h
	jnc	@@m4
	text	<13,10,'Cannot open ROM-file',13,10>
	mov	ax,4c01h
	int	21h
;	
@@m4:	mov	bx,ax
	mov	ds,[cs:emudata]
	mov	cx,16384
	mov	ah,3fh
	xor	dx,dx
	int	21h
	jnc	@@m5
@@m6:	text	<13,10,'Invalid ROM-file',13,10>
	mov	ah,3eh
	int	21h
	mov	ax,4c01h
	int	21h
;	
@@m5:	cmp	ax,16384
	jnz	@@m6
	test	[cs:modes],1
	jnz	@@m7
	mov	ds,[cs:emu128]
	xor	dx,dx
	mov	cx,32768
	mov	ah,3Fh
	int	21h
	jc	@@m6
	cmp	ax,32768
	jnz	@@m6
@@m7:	mov	ah,3eh
	int	21h

;	mov	[byte 565h],0c7h		;Break on Load
;	mov	[byte 4d5h],0c7h		;Break on Save
	push	cs
	pop	ds
; 樠㥬  
mmm:;	jmp	@@m8

	xor	ax,ax
	mov	es,ax
	mov	[ss:21h],al
@@m2:	mov	bl,[ss:21h]
	and	bx,3
	shl	bx,1
	mov	di,[es:bx+400h]
	and	di,di
	jz	@@m9
	mov	si,offset mini1
	call	outsc
	mov	ah,0
	call	incom
	call	sincr
	call	twait
	mov	ax,40bh
	call	outcom
	mov	ch,3
@@m6:	mov	cl,[es:46ch]
@@m4:	mov	ah,5
	call	incom
	test	al,1
	jnz	@@m3
	mov	al,[es:46ch]
	sub	al,cl
	cmp	al,4
	jb	@@m4
@@m3:	mov	ah,0
	call	incom
	cmp	al,4dh
	jz	@@m5
	dec	ch
	jnz	@@m6
@@m9:	inc	[byte ss:21h]
	cmp	[byte ss:21h],4
	jb	@@m2
	jmp	@@m8
@@m5:	call	twait
	mov	ah,5
	call	incom
	mov	si,offset mini2
	call	outsc
	mov	ah,0
	call	incom
	mov	si,offset mini3
	call	outsc
	or	[byte ss:21h],10h
	mov	[ss:24h],di
@@m8:

	;int	3
	cld
	mov	es,[cs:stkseg]
	xor	di,di
	mov	ax,[cs:sysseg]
	stosw
	mov	ax,[cs:stkseg]
	stosw
	mov	ax,[cs:emucode]
	stosw
	mov	ax,[cs:emudata]
	stosw
	mov	ax,[cs:emu128]
	stosw
	mov	ax,[cs:tapseg]
	stosw
	mov	ax,[es:10h]
	mov	[cs:goovl],ax
	mov	[word es:12h],offset debug1
	mov	[word es:14h],offset debug
	mov	[word es:16h],cs
	
extrn	initape:near
	call	initape
; 塞 ⠡  AY-8910 
	push	ss
	pop	es
	mov	di,offset AYFRQS+2
	mov	ax,3FFFh
	stosw
	stosw
	stosw
	stosw
	mov	cx,5
@@j2:	mov	ax,06F8Dh
	mov	dx,4h
	div	cx
	mov	dl,24h			; 24h
@@j0:	test	ah,0FCh
	jz	@@j1
	shr	ax,1
	add	dl,4
	jmp	@@j0
;	
@@j1:	or	ah,dl
	stosw
	inc	cx
	cmp	cx,9
	jb	@@j2

@@j3:	mov	ax,0DF1Bh
	mov	dx,8h
	div	cx
	mov	dl,20h			; 20h
@@j4:	test	ah,0FCh
	jz	@@j5
	shr	ax,1
	add	dl,4
	jmp	@@j4
;	
@@j5:	or	ah,dl
	stosw
	inc	cx
	cmp	cx,4096
	jbe	@@j3
	mov	[AYFRQS],ax

;	int	3
	mov	ch,0			; ⠪  襬 
	mov	di,offset AYATTK
	mov	ax,180h
	stosb
@@j7:	sub	al,10h
	jnz	@@j6
	add	al,10h
@@j6:	mov	cl,ah
	rep	stosb
	rol	ah,1
	jnc	@@j7

	mov	al,10			; 堭  襬 
	stosb
@@ja:	dec	al
	mov	cl,ah
	rep	stosb
	rol	ah,1
	jnc	@@ja

	mov	al,0			; ⠪  襬 
	stosb
@@j9:	sub	al,10h
	mov	cl,ah
	rep	stosb
	rol	ah,1
	jnc	@@j9

	mov	ax,80Fh			; 堭  襬 
	mov	cl,8
	rep	stosb
@@jb:	dec	al
	mov	cl,ah
	rep	stosb
	rol	ah,1
	jnc	@@jb

	call	resadl
	
	call	ressb
	cmp	al,0AAh
	jnz	@@b1
	or	[hard],20h
	mov	al,0D1h
	call	putdsp
@@b1:

; ⠭ breakpoint 
;	mov	bx,[brk]
;	and	bx,bx
;	jz	@@br1
;	dec	bx
;	mov	ds,[emudata]
;	mov	al,0c7h
;	xchg	[bx],al
;	push	ss
;	pop	ds
;	mov	[oldbyt],al
;@@br1:
; ⮢ ⠡ 㪠 
	in	al,61h
	and	al,0feh
	or	al,2
	out	61h,al
	mov	bx,SBIT
@@sn0:	and	al,0fdh
	test	bl,10h
	jz	@@sn1
	or	al,2
@@sn1:	mov	[ss:bx],al
	inc	bl
	jnz	@@sn0
jumps
;    ਭ 
	push	cs
	pop	ds
	push	ss
	pop	es
	cld
	mov	di,LPBUF2+80h
	mov	si,offset lptabs
	mov	ch,0
	mov	cl,[si]
	inc	cl
	rep	movsb
	mov	di,LPBUF2+0C0h
	mov	cl,[si]
	inc	cl
	rep	movsb
	
; 
	;int	3
	mov	cx,17
	mov	si,offset d_pal
	mov	di,PAL
	rep	movsb
	mov	di,KLAVA
	mov	al,0FFh
	mov	cl,8
	rep	stosb
	xor	al,al
	stosb

; 樠 ० 
	push	cs
	pop	ds
	mov	ah,0fh
	int	10h
	mov	[oldmode],al

	xor	ax,ax
	mov	es,ax
	mov	al,[es:489h]
	mov	ah,al
	shr	ah,3
	rol	al,2
	and	ax,202h
	xor	al,ah
	xor	al,2
	shr	al,1
	or	al,ah
	mov	[@oscan],al

	mov	ax,0B800h
	mov	es,ax
	mov	ds,[cs:emudata]
	call	vgmon

	call	putstr
	db	10
	db	'* ZX Spectrum emulator V ',VER,' * ',13,10
	db	' Copyright (c) Programmist X',13,10,10,10
	db	'Type ''? [command]'' to help',13,10,10,0
; 墠 int' 
	push	cs
	pop	ds
	call	setint
	
	;int	3


;	push	ss
;	pop	ds
;	in	al,21h
;	push	ax
	xor	ax,ax
	mov	es,ax
;	cli
	push	[es:8*4] [es:8*4+2]
	pop	[cs:oi8+2] [cs:oi8]

	push	[es:9*4] [es:9*4+2]
	pop	[cs:oi9+2] [cs:oi9]

	push	[es:24h*4] [es:24h*4+2]
	push	[es:60h*4] [es:60h*4+2]

	mov	[es:8*4+2],cs
	mov	[es:9*4+2],cs
	mov	[es:24h*4+2],cs
	mov	[es:60h*4+2],cs
;	mov	[es:61h*4+2],cs
;	mov	[es:62h*4+2],cs
	mov	[word es:8*4],offset int8
	mov	[word es:9*4],offset int9
	mov	[word es:24h*4],offset int24
	mov	[word es:60h*4],offset int60
;	mov	[word es:61h*4],offset int61
;	mov	[word es:62h*4],offset int62
;	mov	ax,23863
;	out	40h,al
;	jmp	short $+2
;	mov	al,ah
;	out	40h,al
;;	pop	ax
;	mov	al,0ach
;	test	[hard],2
;	jnz	@@m1
;	or	al,10h
;@@m1:	out	21h,al
;  樨 

	call	[dword cs:goovl]
	

;  墠祭 
;	in	al,21h
;	push	ax
	cli
	push	ax
	xor	ax,ax
	mov	es,ax
	pop	ax
	pop	[es:60h*4+2] [es:60h*4]
	pop	[es:24h*4+2] [es:24h*4]

	push	[cs:oi9] [cs:oi9+2]
	pop	[es:9*4+2] [es:9*4]

	push	[cs:oi8] [cs:oi8+2]
	pop	[es:8*4+2] [es:8*4]

	push	ax cx dx
	mov	al,34h
	out	43h,al
	
	xor	al,al
	out	40h,al
	jmp	short $+2
	jmp	short $+2
	out	40h,al
;	pop	ax
;	and	al,0feh
;	out	21h,al
	sti
;	nop
	push	cs
	pop	ds

	call	vgmoff
extrn	clostape:near
	call	clostape
	
	call	resadl
	test	[cs:hard],20h
	jz	@@z
	call	ressb
@@z:
jumps
	pop	dx cx ax
	and	ah,ah
	jz	@@6
	cmp	al,20h
	jnz	@@q
	text	<'ERROR: protected mode not available',13,10>
	jmp	@@7
;	
	
@@q:	text	<'Exeption '>
	call	outhexb
	text	' at '
	mov	bp,[ss:0Eh]
	mov	ax,[bp+20]
	call	outhexw
	text	':'
	mov	ax,[bp+18]
	call	outhexw
	text	<13,10>
	mov	si,offset rgss
	cld
@@2:	segcs
	lodsb
	and	al,al
	jz	@@1
	call	putch
	lodsb
	call	putch
	mov	al,'='
	call	putch
	lodsb
	xor	ah,ah
	mov	di,ax
	mov	ax,[bp+di]
	call	outhexw
	mov	al,' '
	call	putch
	jmp	@@2
;	
@@1:	text	<13,10,'Register dump:',13,10>
	mov	bp,[bp+16]
	xor	si,si
@@4:	mov	ax,si
	call	outhexw
@@3:	mov	al,' '
	call	putch
	mov	al,[bp+si]
	call	outhexb
	inc	si
	test	si,0Fh
	jnz	@@3
	mov	al,13
	call	putch
	mov	al,10
	call	putch
	cmp	si,80h
	jnz	@@4
	
	
	
;	text	<13,10,'PC='>
;	call	outhexw
	text	<13,10>

	jmp	@@7
;	
@@6:	
	
text	<13,10,'ZX-SPECTRUM emulator V ',VER,' test. Copyright (c) Programmist X',13,10>
@@7:	mov	ax,4c00h
	int	21h
;
outhexw:push	ax
	mov	al,ah
	call	outhexb
	pop	ax
outhexb:aam	16
	push	ax
	mov	al,ah
	call	outhexn
	pop	ax
outhexn:add	al,90h
	daa
	adc	al,40h
	daa
	mov	ah,0Eh
putch:	mov	dl,al
	mov	ah,2
	int	21h
	ret
;
proc	vinit
	xor	al,al
@@m1:	mov	ah,[cs:si]
	inc	ah
	jz	@@m2
	dec	ah
	inc	si
	out	dx,ax
	inc	al
	jmp	@@m1
@@m2:	ret
endp
;
int24:	mov	al,3
	iret
;
int8:	push	ax
	mov	al,[cs:dirspl]
	cbw
	add	[cs:split],ax
	inc	[cs:intcnt]
	mov	al,20h
	out	20h,al
	pop	ax
	iret
;	
int9:	push	ax
	in	al,60h
	mov	[cs:scanc],al
	in	al,61h
	or	al,80h
	out	61h,al
	and	al,7Fh
	out	61h,al
	mov	al,20h
	out	20h,al
	pop	ax
	iret
;	
int60:	push	ax bx dx
	
	test	[byte ss:23h],4
	jnz	@@i3
	test	[cs:kflg1],80h
	jnz	@@i3
	or	[cs:kflg1],80h
	mov	al,[cs:crtr24]
	mov	dl,al
	mov	ah,3
	mul	ah
	mov	[cs:split],ax
	shr	dl,4
	neg	dl
	mov	[cs:dirspl],dl
	sti
@@i1:	hlt
	mov	dx,3D4h

	mov	al,[cs:crtr7]
	mov	ah,[byte cs:split+1]
	shl	ah,4
	and	ax,10EFh
	or	ah,al
	mov	al,7
	out	dx,ax
	mov	ah,[byte cs:split]
	mov	al,18h
	out	dx,ax

	mov	al,[cs:crtr24]
	mov	ah,0
	cmp	[cs:split],ax
	ja	@@i1

@@i3:	mov	[cs:dirspl],0
	in	al,21h
	mov	[cs:scanc],0
	push	ax
	and	al,0FDh
	out	21h,al

	push	es
	mov	ax,0B800h
	mov	es,ax
	
	test	[byte ss:23h],2
	jz	@@i6
	and	[byte ss:23h],0FDh
@@i8:	call	putstr
	db	13,'QUIT?(Y/N)',0
	call	getkey
	cmp	al,1Ch
	jz	@@i10
	cmp	al,15h
	jnz	@@i7
@@i10:	or	[byte ss:23h],1
	or	[cs:kflg1],40h
	jmp	@@i9
;	
@@i7:	cmp	al,1
	jz	@@i11
	cmp	al,31h
	jnz	@@i8
@@i11:	mov	al,10
	call	putchar
@@i6:	call	setup
@@i9:	pop	es

	test	[byte ss:23h],4
	jnz	@@i5
	test	[cs:kflg1],40h
	jnz	@@i5

	and	[cs:kflg1],7Fh
	mov	al,[cs:crtr24]
	mov	ah,0
	mov	[cs:split],ax
	mov	al,[cs:crtr24]
	shr	al,4
	mov	[cs:dirspl],al

@@i2:	hlt
	mov	dx,3D4h

	mov	al,[cs:crtr7]
	mov	ah,[byte cs:split+1]
	shl	ah,4
	and	ax,10EFh
	or	ah,al
	mov	al,7
	out	dx,ax
	mov	ah,[byte cs:split]
	mov	al,18h
	out	dx,ax

	mov	al,[cs:crtr24]
	mov	ah,3
	mul	ah
	cmp	[cs:split],ax
	jb	@@i2

@@i5:	and	[cs:kflg1],0BFh
	and	[byte ss:23h],0FBh
	pop	ax
	out	21h,al
	pop	dx bx ax
	iret
;
proc	getkey
	sti
	push	di
	mov	di,[cs:cursor]
	add	di,706
	mov	al,[es:di]
	mov	[cs:oldcpos],al

@@0:	mov	al,[cs:oldcpos]
	test	[cs:intcnt],8
	jz	@@2
	xor	al,7Eh
@@2:	mov	[es:di],al
	xor	al,al
	xchg	al,[cs:scanc]
	and	al,al
	jnz	@@1
	hlt
	jmp	@@0
;	
@@1:	cmp	al,2Ah
	jnz	@@a
	or	[cs:kflg1],1
	jmp	@@0
;	
@@a:	cmp	al,36h
	jnz	@@b
	or	[cs:kflg1],2
	jmp	@@0
;	
@@b:	cmp	al,0AAh
	jnz	@@c
	and	[cs:kflg1],0FEh
	jmp	@@0
;	
@@c:	cmp	al,0B6h
	jnz	@@d
	and	[cs:kflg1],0FDh
	jmp	@@0
;	
@@d:	test	al,80h
	jnz	@@0
	mov	ah,[cs:oldcpos]
	mov	[es:di],ah
	pop	di
	ret
endp
;
proc	getstr
	push	bx si

@@3a:	xor	si,si
@@3:	call	getkey
	cmp	al,1
	jz	@@1
	cmp	al,53h
	jbe	@@2
	cmp	al,5Bh
	jb	@@3
	cmp	al,5Dh
	ja	@@3
	call	putstr
	db	13,'>MustDie        ',13,10,'>',0
	jmp	@@3a
;	
@@2:	mov	bx,offset scanxlt
	test	[cs:kflg1],3
	jz	@@5
	mov	bx,offset scanxl2
@@5:	segcs
	xlat
	cmp	al,8
	jnz	@@6
	and	si,si
	jz	@@3
	dec	si
	call	putstr
	db	8,32,8,0
	jmp	@@3
;	
@@6:	mov	[cs:inbuf+si],al
	push	ax
	call	putchar
	pop	ax
	inc	si
	cmp	al,13
	jz	@@7
	cmp	si,28
	jb	@@3
	dec	si
	push	ax
	mov	al,8
	call	putchar
	pop	ax
	jmp	@@3
;	
@@7:	push	ax
	mov	al,10
	call	putchar
	pop	ax

@@1:	pop	si bx
	ret
endp
;
proc	getscf
	push	bx cx dx si ds cs
	pop	ds
@@9:	mov	si,[io2pt]
@@2:	cmp	si,256
	jae	@@1
	cmp	[byte io2buf+si],13
	jz	@@3
	inc	si
	jmp	@@2
;	
@@3:	lea	bx,[si+1]
	lea	cx,[bx+1]
	mov	si,[io2pt]
	mov	[io2pt],cx
	sub	bx,si
	jz	@@2
	cmp	bx,32
	jb	@@4
	mov	bx,32
@@4:	mov	[byte inbuf+bx-1],13
	dec	bx
	jz	@@11
@@12:	mov	al,[io2buf+si+bx-1]
	mov	[inbuf+bx-1],al
	dec	bx
	jnz	@@12
@@11:	mov	al,13
	jmp	@@5
;	
@@1:	mov	bx,[io2pt]
	xor	si,si
	mov	[io2pt],si
@@7:	cmp	bx,256
	jae	@@6
	mov	al,[io2buf+bx]
	mov	[io2buf+si],al
	inc	bx
	inc	si
	jmp	@@7
;	
@@6:	mov	bx,[sfh]
	mov	cx,256
	sub	cx,si
	mov	dx,si
	add	dx,offset io2buf
	mov	ah,3Fh
	int	21h
	jc	@@8
	and	ax,ax
	jz	@@8
	cmp	ax,cx
	jz	@@9
	mov	si,dx
	add	si,ax
@@10:	mov	[byte si],0
	inc	si
	cmp	si,offset io2buf+256
	jb	@@10
	jmp	@@9
;	
@@8:	mov	al,1
@@5:	pop	ds si dx cx bx
	ret
endp
;
proc	putchar
	and	al,7Fh
	cmp	al,32
	jae	@@5
	cmp	al,13
	jnz	@@6
	and	[cs:cursor],0FE00h
	ret
;	
@@6:	cmp	al,10
	jnz	@@7
	push	di
	mov	di,[cs:cursor]
	add	di,512
	call	@@scr
	mov	[cs:cursor],di
	pop	di
	ret
;	
@@7:	cmp	al,8
	jnz	@@8
	push	di
	mov	di,[cs:cursor]
	sub	di,2
	jc	@@7a
	mov	ax,di
	and	al,3Eh
	cmp	al,3Eh
	jnz	@@7b
	sub	di,4
@@7b:	mov	[cs:cursor],di
@@7a:	pop	di
	ret
;	
@@8:
	ret
;	
@@5:	push	bx di
	mov	di,[cs:cursor]
	call	@@scr
	mov	bl,al
	mov	bh,0
	shl	bx,3
IRPC	x,01234567
	mov	al,[cs:FONT-256+bx+x]
	mov	[es:di+258+64*x],al
ENDM
	inc	di
	inc	di
	mov	ax,di
	and	ax,3Eh
	cmp	ax,3Ch
	jb	@@1
	add	di,452

@@1:	mov	[cs:cursor],di
	
	pop	di bx
	ret
;	
@@scr:	cmp	di,7680
	jb	@@2
	push	di si cx
	cld
	mov	di,256
	lea	si,[di+512]
	mov	cx,3584
	seges
	rep	movsw

	mov	ch,8
@@4:	inc	di
	inc	di
	mov	cl,30
@@3:	mov	[byte es:di],0
	inc	di
	inc	di
	dec	cl
	jnz	@@3
	inc	di
	inc	di
	dec	ch
	jnz	@@4
	pop	cx si di
	sub	di,512
@@2:	ret
endp
;
proc	putstr
	push	ax si bp
	mov	bp,sp
	cld
	mov	si,[bp+6]
	call	putascz
	mov	[bp+6],si
	pop	bp si ax
	ret
endp
;
proc	putascz
@@0:	segcs
	lodsb
	and	al,al
	jnz	@@1
	ret
;	
@@1:	call	putchar
	jmp	@@0
endp
;
P186
jumps
proc	vgmon
	;int	3
	
	mov	di,VIDEO
;	xor	ax,ax
	mov	ax,VPAGE1

@@u3:	mov	ch,0c0h
@@m2:	mov	cl,32
@@m1:	mov	[ss:di],ax
	inc	di
	inc	di
	inc	ax
	inc	ax
	dec	cl
	jnz	@@m1
	add	ax,448
	dec	ch
	test	ch,7
	jnz	@@m2
	sub	ax,4032
	test	ch,38h
	jnz	@@m2
	add	ax,3584
	test	ch,0c0h
	jnz	@@m2

	mov	di,AVIDEO
	mov	ax,1+VPAGE1
	mov	ch,24
@@a1:	mov	cl,32
@@a2:	mov	[ss:di],ax
	inc	di
	inc	di
	inc	ax
	inc	ax
	dec	cl
	jnz	@@a2
	add	ax,448
	dec	ch
	jnz	@@a1

	mov	si,offset video2
	mov	di,VIDEO+3000h
	mov	cx,128
@@a3:	segcs
	lodsw
	mov	[ss:di],ax
	inc	di
	inc	di
	loop	@@a3
	
	test	[cs:hard],10h
	jz	@@1

	mov	ax,1200h
	mov	bl,30h
	int	10h
	mov	ax,1
	int	10h
	
	mov	dx,3D4h
	mov	al,11h
	out	dx,al
	inc	dx
	in	al,dx
	and	al,7Fh
	out	dx,al
	dec	dx
	mov	ax,1F01h
	out	dx,ax
	mov	al,12h
	out	dx,al
	inc	dx
	in	al,dx
	mov	cl,al
	dec	dx

	test	[cs:hard],80h
	jnz	@@a
	mov	[cs:crtr24],64
@@a:	mov	al,7
	out	dx,al
	inc	dx
	in	al,dx
	test	al,40h
	jnz	@@6
	test	al,2
	jz	@@7
	cmp	cl,8Fh
	jae	@@6
@@7:	mov	cl,0BFh
	and	al,0ADh
	out	dx,al
	test	[cs:hard],80h
	jnz	@@b
	mov	[cs:crtr7],al
@@b:	dec	dx
	mov	al,9
	out	dx,al
	inc	dx
	in	al,dx
	and	al,0BFh
	out	dx,al
	jmp	@@8
;	
@@6:	test	[cs:hard],80h
	jnz	@@c
	mov	[cs:crtr24],128
@@c:	mov	cl,7Fh
	and	al,0BFh
	or	al,12h
	test	[cs:hard],80h
	jnz	@@d
	mov	[cs:crtr7],al
@@d:	out	dx,al
	dec	dx
	mov	ax,9018h
	out	dx,ax
	mov	al,9
	out	dx,al
	inc	dx
	in	al,dx
	or	al,80h
	and	al,0BFh
	out	dx,al

@@8:	dec	dx
	mov	al,18
	mov	ah,cl
	out	dx,ax
	mov	ax,1013h
	out	dx,ax
	mov	al,9
	out	dx,al
	inc	dx
	in	al,dx
	and	al,0E0h
	out	dx,al
	dec	dx
	mov	al,11h
	out	dx,al
	inc	dx
	in	al,dx
	or	al,80h
	out	dx,al
	dec	dx
	mov	ax,00Eh
	out	dx,ax
	mov	ax,(VPAGE1 SHR 1) OR 0Ch
	out	dx,ax
	mov	ax,0Dh
	out	dx,ax

	mov	dx,3DAh
	in	al,dx
	mov	dx,3C0h
	mov	al,10h
	out	dx,al
	mov	al,0
	out	dx,al

	mov	dx,3C4h
	mov	ax,402h
	out	dx,ax
	mov	ax,704h
	out	dx,ax
	xor	di,di
	xor	al,al
@@2a:	stosb
	add	di,31
	inc	al
	jnz	@@2a
	mov	ax,302h
	out	dx,ax
	mov	ax,304h
	out	dx,ax
	jmp	@@vga
;	

@@1:	mov	ax,1			;1- ०
	int	10h
	mov	dx,3DAh
	in	al,dx
	mov	dx,3c0h
	mov	al,10h
	out	dx,al
	mov	al,0
	out	dx,al
	mov	dx,3c4h
	mov	si,offset seqtab
	call	vinit
	mov	ax,300h
	out	dx,ax

	xor	di,di
@@vi1:	stosb
	add	di,31
	inc	al
	jnz	@@vi1

	mov	ax,302h
	out	dx,ax
	mov	ax,304h
	out	dx,ax
	test	[cs:hard],1		;If VGA active
	jz	@@ega

	mov	al,[cs:crtvga+7]
	test	[cs:hard],80h
	jnz	@@e
	mov	[cs:crtr7],al
	mov	[cs:crtr24],128
@@e:	mov	dx,3c2h
	mov	al,0e3h
	out	dx,al
	mov	dx,3d4h
	mov	si,offset crtvga
	mov	ax,2411h
	out	dx,ax
	call	vinit

@@vga:	
	mov	dx,3C8h
	xor	al,al
	out	dx,al
	halt	2
	inc	dx
	cld
	mov	si,offset rgb
	mov	cx,8*3
@@z:	segcs
	lodsb
	out	dx,al
	halt	2
	loop	@@z

	jmp	@@goto
;	
@@ega:	mov	al,[cs:crtega+7]
	test	[cs:hard],80h
	jnz	@@f
	mov	[cs:crtr7],al
	mov	[cs:crtr24],64

@@f:	mov	dx,3c2h
	mov	al,023h
	out	dx,al
	mov	dx,3d4h
	mov	si,offset crtega
	mov	ax,2411h
	out	dx,ax
	call	vinit

@@goto:	
	mov	dx,3dah
	in	al,dx
	mov	dx,3c0h
	mov	al,13h
	out	dx,al
	mov	al,0
	out	dx,al

	mov	si,offset pal
	mov	ah,0
@@2:	mov	dx,3DAh
	in	al,dx
	mov	dx,3C0h
	mov	al,ah
	out	dx,al
	segss
	lodsb
	out	dx,al
	inc	ah
	cmp	ah,10h
	jb	@@2
	ja	@@3
	mov	ah,30h
	jmp	@@2
;	

@@3:	mov	si,4000h
	mov	cx,1800h
@@4:	add	si,si
	mov	di,[ss:si+VIDEO-8000h]
	shr	si,1
	movsb
	loop	@@4

	mov	cx,300h
	mov	bx,offset VIDEO+3000h
@@5:	shl	si,1
	mov	di,[ss:si+AVIDEO-0B000h]
	shr	si,1
	lodsb
	and	al,[@flash]
	segss
	xlat
	mov	[es:di],al
	mov	[es:di+40h],al
	mov	[es:di+80h],al
	mov	[es:di+0C0h],al
	mov	[es:di+100h],al
	mov	[es:di+140h],al
	mov	[es:di+180h],al
	mov	[es:di+1C0h],al
	loop	@@5

;	int	3
	xor	di,di
	mov	ax,1FFFh
	mov	cx,32
	rep	stosw
	mov	bl,126
@@9:	mov	al,80h
	stosw
	mov	ax,1E00h
	mov	cl,30
	rep	stosw
	mov	ax,1F01h
	stosw
	dec	bl
	jnz	@@9
	mov	al,0FFh
	mov	cl,32
	rep	stosw
	test	[cs:hard],80h
	jnz	@@h
	mov	[cs:cursor],0
	or	[cs:hard],80h
@@h:	ret
endp
;	
proc	vgmoff
	test	[cs:hard],10h
	jz	@@5
	mov	ah,12h
	mov	al,[cs:@oscan]
	mov	bl,30h
	int	10h
@@5:	mov	al,[cs:oldmode]
	mov	ah,0
	int	10h
	ret
endp
;	
proc	vgmtext
	pusha
	cld
	mov	di,VIDEO
	mov	cx,1B00h
	mov	ax,3E00h
@@1:	mov	[ss:di],ax
	inc	di
	inc	di
	loop	@@1
	test	[cs:hard],10h
	jz	@@5
	mov	ah,12h
	mov	al,[cs:@oscan]
	mov	bl,30h
	int	10h
@@5:	mov	ax,3
	int	10h
	popa
	ret
endp	
NOJUMPS
;
proc	toupper
	cmp	al,'a'
	jb	@@1
	cmp	al,'z'
	jbe	@@2
	call	[dword cs:casemap]
	ret
@@2:	sub	al,20h
@@1:	ret
endp
;
public	vgmon
public	vgmoff
public	vgmtext
;proc	debug	far
;	jmp	[word ss:12h]
;   맮 
;debug1:	call	vgmtext
;	pusha
;	mov	[word ss:12h],offset debug2
;	mov	[byte ss:0Dh],0
;	mov	[@debmode],1
;	call	scrupd
;@@1:	call	@getscan
;	cmp	al,1
;	jnz	@@1
;	popa
;	ret
;  ⨢ 	
;debug2:	
;	ret
; 	
;endp
;
;proc	@inkey
;	mov	al,[ss:0Dh]
;	dec	al
;	mov	al,[ss:0Ch]
;	ret
;endp
;proc	@getscan
;@@0:	mov	al,[ss:0Dh]
;	dec	al
;	jz	@@1
;	hlt
;	jmp	@@0
;	
;@@1:	mov	[ss:0Dh],al
;	mov	al,[ss:0Ch]
;	ret
;endp
;
;proc	scrupd
;	cld
;	mov	si,offset ctls
;@@0:	segcs
;	lodsw
;	inc	ax
;	jnz	@@2
;	ret
;		
;@@2:	dec	ax
;	mov	di,ax
;	segcs
;	lodsw
;;	mov	cl,[@debmode]
;	shr	ax,cl
;	jc	@@1
;	add	si,4
;	jmp	@@0
;;	
;@@1:	segcs
;	lodsw
;	mov	cl,ah
;	and	ax,7
;	add	ax,ax
;	mov	bx,ax
;	segcs
;	lodsw
;	push	si
;	call	[@ctltyps+bx]
;	pop	si
;	jmp	@@0
;;		
;@@h4:
	
;	ret
;		
;@@h2:	xchg	ax,bx
;	mov	al,[bx]
;	aam	16
;	xchg	al,ah
;	call	@@h1
;	xchg	al,ah
;@@h1:	add	al,90h
;	daa
;	adc	al,40h
;	daa
;	mov	ah,ch
;	stosw
;	ret
;		
;@@tx:	xchg	ax,si
;	mov	ah,cl
;@@t0:	segcs
;	lodsb
;	and	al,al
;	jz	@@t1
;	stosw
;	jmp	@@t0
;@@t1:	ret
;		
;@ctltyps dw	@@tx,@@h2,@@h4,@@tx,@@tx,@@tx,@@tx,@@tx
;endp
;		
;macro	@text	y,x,p,a
;	local	@@txt
;	dw	y*160+x*2,p,700h,@@txt
;dataseg
;@@txt	db	a,0
;codeseg
;endm
;		
;ctls:
;	@text	0,0,1,'Text'
	
;	dw	-1
;
proc	setint
	and	[byte ss:20h],0FEh
	mov	al,34h
	out	43h,al
	halt	2
	mov	al,[rate]
	dec	al
	jnz	@@1
	mov	ax,5D37h
	jmp	@@1a
;	
@@1:	dec	al
	jnz	@@2
	mov	ax,308Ch
@@1a:	mov	[ss:18h],ax
	out	40h,al
	halt	2
	mov	al,ah
	out	40h,al
	jmp	@@qz
;	
@@2:	dec	al
	jz	@@3
	ret
;	
@@3:	or	[byte ss:20h],1
	
	out	40h,al
	halt	2
	out	40h,al
	mov	dx,3DAh
	
REPT	2
	local	@@1,@@2
@@1:	in	al,dx
	test	al,8
	jnz	@@1
@@2:	in	al,dx
	test	al,8
	jz	@@2
	xor	al,al
	out	43h,al
	halt	2
	in	al,40h
	mov	ah,al
	halt	2
	in	al,40h
	xchg	al,ah
	xchg	cx,ax
ENDM	
	sub	ax,cx
	sub	ax,3
	mov	[ss:18h],ax
	push	ax
	mov	al,34h
	out	43h,al
	halt	2
	pop	ax
	out	40h,al
	halt	2
	mov	al,ah
	out	40h,al

@@qz:	mov	ax,380
	mul	[word ss:18h]
	mov	[ss:1Ah],dx
	mov	[word ss:1Ch],0
	ret
endp
;
proc	resadl
	mov	si,offset tbadl
	jmp	@@0
;	
@@2:	mov	dx,388h
	xchg	al,ah
	out	dx,al
	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
	in	al,dx
	xchg	al,ah
	inc	dx
	out	dx,al
	mov	cx,23h
@@1:	in	al,dx
	loop	@@1
@@0:	lodsw
	and	ax,ax
	jnz	@@2
	ret
endp
;
proc	ressb
	mov	dx,226h
	mov	al,1
	out	dx,al
	in	al,0EDh
	in	al,0EDh
	in	al,0EDh
	in	al,0EDh
	mov	al,0
	out	dx,al
	mov	cx,200
	add	dl,8
@@1:	in	al,dx
	test	al,80h
	loopz	@@1
	jz	@@2
	sub	dl,4
	in	al,dx
	ret

@@2:	xor	al,al
	ret
endp
;
proc	putdsp
	mov	ah,al
	mov	cx,200
	mov	dx,22Ch
@@2:	in	al,dx
	test	al,80h
	loopnz	@@2
	mov	al,ah
	out	dx,al
	ret
endp
;
setbrd:	mov	ah,al
	mov	dx,3dah
	in	al,dx
	mov	dx,3c0h
	mov	al,31h
	out	dx,al
	mov	al,ah
	out	dx,al
	ret
outcom:	mov	bl,ah
	mov	bh,0
	lea	dx,[bx+di]
	out	dx,al
	ret
incom:	mov	bl,ah
	mov	bh,0
	lea	dx,[bx+di]
	in	al,dx
	ret
sincr:	mov	al,[es:46ch]
@@si1:	cmp	al,[es:46ch]
	jz	@@si1
	ret
twait:	mov	cx,4
@@de1:	call	sincr
	loop	@@de1
@ret:	ret
outsc:	lodsw
	cmp	ax,0ffffh
	jz	@ret
	call	outcom
	jmp	outsc
;
@vgabios:
	or	[hard],10h
	ret
@covox:	or	[hard2],2
	ret
@debug:	or	[hard2],4
	ret
@noadl:	and	[hard2],0F7h
	ret
@emr1:	or	[hard2],30h
	ret
@emr0:	or	[hard2],20h
	ret
;	
align	2
;
proc	setup

@@0:	call	putstr
	db	13,'>',0
	test	[byte ss:23h],4
	jz	@@0a
	push	ds cs
	pop	ds
	cmp	[sfh],0
	jnz	@@0b
	mov	dx,offset sfile
	mov	ax,3D00h
	int	21h
	jnc	@@0c
;	and	[byte ss:23h],0FBh
	pop	ds
	jmp	@@0g
;	
@@0c:	mov	[sfh],ax
	mov	[io2pt],256
@@0b:	call	getscf
	pop	ds
	jmp	@@0d
;	
;@@0e:	pop	ds
@@0a:	call	getstr
@@0d:	cmp	al,1
	jnz	@@1
@@0g:	cmp	[cs:sfh],0
	jz	@@0f
	mov	ah,3Eh
	mov	bx,[cs:sfh]
	int	21h
	mov	[cs:sfh],0
@@0f:	ret
;	
@@5:	call	putstr
	db	'Unknown command',13,10,0
	jmp	@@2
;	
@@1:	push	si
	xor	si,si
	call	findcmd
	cmp	ax,13
	jz	@@2
	and	ax,ax
	jz	@@5
	push	di
	mov	di,ax
	mov	ax,[cs:di]
	pop	di
	call	ax
@@2:	pop	si
	jmp	@@0
endp
;		
@cont:	pop	si ax
	or	[cs:kflg1],40h
	ret
@quit:	pop	si ax
	or	[byte ss:23h],1
	or	[cs:kflg1],40h
	ret
;	
proc	@help
;	call	nextarg
;	cmp	al,13
;	jz	@@1
	call	findcmd
	cmp	ax,13
	jbe	@@1
	push	si
	mov	si,ax
	mov	si,[cs:si+2]
	call	putascz
	pop	si
	
	
	ret
;	
@@1:	call	putstr
	db	'CLS            CONTinue',13,10
	db	'DELAy          DISK',13,10
	db	'HELP           LOAD',13,10
	db	'PRINt          RESEt',13,10
	db	'QUIT           ?',13,10
	db	0
	ret
endp
; 
proc	@cls
	push	di cx
	mov	di,258
	mov	ch,120
@@2:	mov	cl,30
@@1:	mov	[byte es:di],0
	inc	di
	inc	di
	dec	cl
	jnz	@@1
	add	di,4
	dec	ch
	jnz	@@2
	pop	cx di
	mov	[cs:cursor],0
	ret
endp
; 
proc	@res
	push	bx
	mov	bl,1
	call	nextarg
	cmp	al,13
	jz	@@1
	mov	al,[cs:inbuf+si]
	cmp	al,'1'
	jz	@@1
	inc	bl
	cmp	al,'4'
	jz	@@1
	inc	bl
	call	ucase
	cmp	al,'D'
	jz	@@1
	cmp	al,'T'
	jz	@@1
	mov	bl,1
@@1:	mov	[@pc],0
	mov	[@trdos],0
	xor	al,al
	dec	bl
	jz	@@2
	mov	al,30h
	dec	bl
	jz	@@2
	mov	al,10h
	mov	[@trdos],1
@@2:	mov	[@sysprt],al
	pop	bx
	ret
endp
; 
proc	@disk
	push	bx
	call	nextarg
	cmp	al,13
	jz	@@1
	mov	al,[cs:inbuf+si]
	call	ucase
	sub	al,'A'
	jb	@@1
	cmp	al,4
	jae	@@1
	mov	bl,al
	mov	bh,0
	add	bx,bx
	call	nextarg
	cmp	al,13
	jz	@@5
	push	di
	mov	di,[ss:26h+bx]
@@7:	mov	al,[cs:inbuf+si]
	mov	[ss:di],al
	inc	si
	inc	di
	cmp	al,' '
	jz	@@8
	cmp	al,13
	jnz	@@7
@@8:	mov	[byte ss:di-1],0
	cmp	[word ss:2Eh+bx],0
	jz	@@8a
	mov	ah,3Eh
	push	bx
	mov	bx,[word ss:2Eh+bx]
	int	21h
	pop	bx
	mov	[word ss:2Eh+bx],0
@@8a:	pop	di

@@5:	call	@@put1
	jmp	@@6
;		
@@1:	xor	bx,bx
@@4:	call	@@put1
	inc	bl
	inc	bl
	cmp	bl,8
	jb	@@4
@@6:	pop	bx
	ret
;	
@@put1:	mov	al,' '
	cmp	[word ss:2Eh+bx],0
	jz	@@0
	mov	al,'*'
@@0:	call	putchar
	mov	al,bl
	shr	al,1
	add	al,'A'
	call	putchar
	call	putstr
	db	' => ',0
	mov	si,[ss:26h+bx]
@@3:	segss
	lodsb
	and	al,al
	jz	@@2
	call	putchar
	jmp	@@3
;	
@@2:	call	putstr
	db	13,10,0
	ret
endp
;
proc	@dela
	push	bx cx dx
	
	call	nextarg
	cmp	al,13
	jz	@@1
	xor	bl,bl
	mov	ax,[word cs:inbuf+si]
	xchg	al,ah
	sub	ah,'0'
	jb	@@2
	cmp	ah,9
	ja	@@2
	mov	bl,ah
	sub	al,'0'
	jb	@@2
	cmp	al,9
	ja	@@2
	aad
	mov	bl,al
@@2:	cmp	bl,70
	jbe	@@4
	mov	bl,70
@@4:	mov	[cs:curdel],bl

	mov	al,bl
	mov	bx,MLOOP
	and	al,al
	jz	@@e1
	mov	bx,MLOOPD
	mov	cx,8
@@e3:	dec	al
	jz	@@e2
	mov	dx,cx
	shr	dx,1
	shr	dx,1
	shr	dx,1
	add	cx,dx
	jmp	@@e3
;	
@@e2:	sub	cx,7
	mov	[@halt],cx
@@e1:	mov	[@cycle],bx
	
@@1:	call	putstr
	db	'Delay = ',0
	mov	al,[cs:curdel]
	aam
	xor	ax,'00'
	push	ax
	mov	al,ah
	cmp	al,'0'
	jz	@@3
	call	putchar
@@3:	pop	ax
	call	putchar
	call	putstr
	db	13,10,0
	
	pop	dx cx bx
	ret
endp
;
proc	@prn
	call	nextarg
	cmp	al,13
	jnz	@@1
	ret
;	
@@1:	mov	al,[cs:inbuf+si]
	and	al,0DFh
	cmp	al,'S'
	jnz	@@1
	push	cx dx si di ds
	xor	si,si
	mov	ds,si
	mov	dx,[408h]
	mov	ax,[cs:emudata]
	add	ax,400h
	test	[@sysprt],8
	jz	@@2
	mov	ax,[cs:emu128]
	add	ax,1800h
@@2:	mov	ds,ax
	cld
@@7:	mov	al,27
	call	prnch
	mov	al,'*'
	call	prnch
	mov	al,5
	call	prnch
	mov	al,0
	call	prnch
	mov	al,1
	call	prnch
	mov	ch,32
@@6:	mov	cl,8
@@4:	mov	al,[si]
	xor	di,di
@@3:	shl	al,1
	rcl	[cs:bufprn+di],1
	inc	di
	cmp	di,8
	jb	@@3
	add	si,256
	dec	cl
	jnz	@@4
	xor	di,di
@@5:	mov	al,[cs:bufprn+di]
	call	prnch
	inc	di
	cmp	di,8
	jb	@@5
	sub	si,2047
	dec	ch
	jnz	@@6
	mov	al,13
	call	prnch
	mov	al,27
	call	prnch
	mov	al,'J'
	call	prnch
	mov	al,24
	call	prnch
	test	si,100h
	jz	@@7
	add	si,1792
	cmp	si,6144
	jb	@@7
endpr:	pop	ds di si dx cx
	ret
;	
prnch:	call	prnch1
	jnc	@@p1
	pop	cx
	test	al,10h
	jnz	@@p2
	call	putstr
	db	'Printer is not selected',13,10,0
	jmp	endpr
;	
@@p2:	call	putstr
	db	'Printer is not ready',13,10,0
	jmp	endpr
;	
@@p1:	ret
endp
;	
proc	prnch1
	push	cx
	mov	cx,-1
	mov	ah,al
	inc	dx
@@2:	in	al,dx
	test	al,10h
	jz	@@1
	test	al,80h
	loopz	@@2
	jz	@@1
	dec	dx
	mov	al,ah
	out	dx,al
	out	dx,al
	inc	dx
	inc	dx
	mov	al,0Dh
	out	dx,al
	in	al,dx
	in	al,dx
	in	al,dx
	mov	al,0Ch
	out	dx,al
	in	al,dx
	in	al,dx
	in	al,dx
	dec	dx
	dec	dx
	stc
	sbb	al,al
@@1:	cmc
	pop	cx
	ret
endp
;
proc	@load
	call	nextarg
	cmp	al,13
	jnz	@@1
	call	putstr
	db	'Nothing to load',13,10,0
	ret
;	
@@1:	push	ax dx ds
	push	cs
	pop	ds
	mov	di,offset fnbuf
	mov	dx,di

@@3:	mov	al,[inbuf+si]
	call	ucase
	mov	[di],al
	inc	si
	inc	di
	cmp	al,13
	jz	@@2
	cmp	al,' '
	jnz	@@3
@@2:	dec	di
	mov	[byte di],0
	mov	ax,di
	push	cx
	mov	cx,4
@@5:	dec	di
	cmp	[byte di],'.'
	loopnz	@@5
	pop	cx
	jz	@@6
	mov	di,ax
	mov	[ldmode],0
	jmp	@@9
;	
@@6:	cmp	[word di+1],'8Z'
	jnz	@@7
	cmp	[byte di+3],'0'
	jnz	@@7
	mov	[ldmode],1
	jmp	@@9
;	
@@7:	cmp	[word di+1],'NS'
	jnz	@@8
	cmp	[byte di+3],'A'
	jnz	@@8
	mov	[ldmode],2
	jmp	@@9
;	
@@8:	mov	[ldmode],-1
@@9:	mov	ax,3D00h
	int	21h
	jc	@@4
@@10:	push	cx bx
	mov	bx,ax
	mov	al,[ldmode]
@@11:	dec	al
	jnz	@@12
	call	ld_z80
	jmp	@@14a
;	
@@12:	dec	al
	jnz	@@13
	call	ld_sna
@@14a:	jnc	@@14
	call	putstr
	db	'Load error',13,10,0
	jmp	@@14
;	
@@13:
@@14:	mov	ah,3Eh
	int	21h
	pop	bx cx
	pop	ds dx ax
	jmp	scrfsh
;	
@@4:	mov	[word di],'Z.'
	mov	[word di+2],'08'
	mov	[byte di+4],0
	mov	[ldmode],1
	mov	ax,3D00h
	int	21h
	jnc	@@10
	mov	[word di],'S.'
	mov	[word di+2],'AN'
	mov	[byte di+4],0
	mov	[ldmode],2
	mov	ax,3D00h
	int	21h
	jnc	@@10
	pop	ds dx ax
	call	putstr
	db	'File not found',13,10,0
	ret
endp
; 
jumps
proc	ld_z80
	push	ds
	push	cs
	pop	ds
	mov	dx,offset iobuf
	mov	cx,30
	mov	ah,3Fh
	int	21h
	jc	@@1
	cmp	ax,cx
	jnz	@@1
	cmp	[word iobuf+6],0
	jnz	@@2
	mov	dx,offset iobuf+30
	mov	cx,2
	mov	ah,3Fh
	int	21h
	jc	@@1
	cmp	ax,cx
	jnz	@@1
	mov	cx,[word iobuf+30]
	cmp	cx,54
	ja	@@1
	mov	dx,offset iobuf+32
	mov	ah,3Fh
	int	21h
	jc	@@1
	cmp	ax,cx
	jnz	@@1
	mov	al,[byte iobuf+34]
	cmp	[byte iobuf+30],23
	ja	@@q1
	cmp	al,1
	jbe	@@q2
	cmp	al,3
	jb	@@1
	cmp	al,4
	ja	@@1
@@q4:	mov	[mod128],1
	jmp	@@c
;	
@@q2:	mov	[mod128],0
	jmp	@@c
;	
@@q1:	cmp	al,2
	jbe	@@q2
	cmp	al,4
	jb	@@1
	cmp	al,6
	jbe	@@q4
@@1:	pop	ds
	stc
	ret
;	
@@c:	push	cs
	pop	ds
	mov	dx,offset iobuf+200
	mov	cx,3
	mov	ah,3Fh
	int	21h
	jc	@@1
	cmp	ax,cx
	jnz	@@d
	call	unpz80
	jmp	@@c
;	
@@d:	mov	si,offset iobuf+32
	lodsw
	mov	[word iobuf+6],ax
	inc	si
	lodsb
	cmp	[mod128],0
	jnz	@@f
	mov	al,10h
@@f:	mov	[@sysprt],al
	add	si,3
	lea	di,[@ayrgs]
	mov	cx,8
	push	es ss
	pop	es
	rep	movsw
	pop	es
	jmp	@@4
;	
@@2:	mov	[@sysprt],30h
	mov	ds,[emudata]
	mov	dx,4000h
	test	[byte cs:iobuf+12],20h	; V <= 1.45
	jnz	@@3
	mov	cx,0C000h
	mov	ah,3Fh
	int	21h
	jc	@@1
	cmp	ax,cx
	jnz	@@1
	jmp	@@4
;	
@@3:	mov	cx,0C000h

	call	unpz80a

@@4:	push	cs
	pop	ds
	mov	si,offset iobuf
	lodsw
	xchg	al,ah
	mov	[word @f],ax
	lodsw
	mov	[@bc],ax
	lodsw
	mov	[@hl],ax
	lodsw
	mov	[@pc],ax
	lodsw
	mov	[@sp],ax	
	lodsb
	mov	[@i],al
	lodsw
	shl	al,1
	shr	ax,1
	mov	[@r],al
	mov	al,ah
	and	al,7
	mov	[@brd],al
	lodsw
	mov	[@de],ax
	lodsw
	mov	[@_bc],ax
	lodsw
	mov	[@_de],ax
	lodsw
	mov	[@_hl],ax
	lodsw
	xchg	al,ah
	mov	[@_af],ax
	lodsw
	mov	[@iy],ax
	lodsw
	mov	[@ix],ax
	lodsw
	and	al,al
	jz	@@7
	mov	al,4
@@7:	mov	[@iff],al
	lodsb
	and	al,3
	mov	[@im],al

@@e:	pop	ds
	clc
	ret
endp
; 
proc	unpz80
	mov	cx,4000h
	push	es cx
	mov	cx,[word cs:iobuf+200]
	mov	al,[cs:iobuf+202]
	and	al,al
	jnz	@@8
	mov	ds,[cs:emudata]
	xor	dx,dx
	jmp	@@7
;	
@@8:	cmp	al,2
	jnz	@@9
	mov	ds,[cs:emu128]
	xor	dx,dx
	jmp	@@7
;	
@@9:	sub	al,3
	jb	@@10
	cmp	al,7
	ja	@@10
	cmp	[cs:mod128],0
	jnz	@@11
	cmp	al,2
	ja	@@11
	inc	al
	cmp	al,2
	jbe	@@11
	xor	al,al
@@11:	call	pageadr
	jmp	@@7
;	
@@10:	mov	ds,[cs:tapseg]
	mov	dx,0
	mov	ah,3Fh
	int	21h
	pop	cx es
	ret
;	
unpz80a:
	push	es cx
	mov	cx,0FF00h
@@7:	mov	di,dx
	push	ds
	mov	ds,[cs:tapseg]
	mov	dx,0
	mov	ah,3Fh
	int	21h
	pop	es cx

	mov	si,dx
@@0:	lodsb
	cmp	al,0EDh
	jz	@@1
	stosb
	loop	@@0
	jmp	@@2
;	
@@1:	loop	@@3
	stosb
	jmp	@@2
;	
@@3:	lodsb
	cmp	al,0EDh
	jz	@@6
	mov	ah,al
	mov	al,0EDh
	stosw
	loop	@@0
	jmp	@@2
;	
@@6:	inc	cx
	lodsb
	mov	ah,al
	lodsb
@@5:	stosb
	dec	ah
	jz	@@4
	loop	@@5
	jmp	@@2
;	
@@4:	loop	@@0
@@2:	push	es
	pop	ds
	pop	es
	ret
endp
; 
proc	ld_sna
	push	ds
	mov	dx,offset iobuf
	mov	cx,27
	mov	ah,3Fh
	int	21h
	jc	@@1
	cmp	ax,cx
	jnz	@@1

	mov	[@sysprt],10h	;; 48K-mode
	mov	ds,[emudata]
	mov	cx,0C000h
	mov	dx,4000h
	mov	ah,3Fh
	int	21h
	jc	@@1
	cmp	ax,cx
	jz	@@3
@@1:	pop	ds
	stc
	ret
;	
@@3:	push	cs
	pop	ds
	mov	dx,offset iobuf+30
	mov	cx,4
	mov	ah,3Fh
	int	21h
	jc	@@1
	cmp	ax,cx
	jnz	@@2
	;;; SNA 128
	
	
@@2:
	mov	ah,3Eh
	int	21h
	
	mov	si,offset iobuf
	push	cs
	pop	ds
	lodsb
	mov	[@i],al
	lodsw
	mov	[@_hl],ax	
	lodsw
	mov	[@_de],ax
	lodsw
	mov	[@_bc],ax
	lodsw
	mov	[@_af],ax
	lodsw
	mov	[@hl],ax
	lodsw
	mov	[@de],ax
	lodsw
	mov	[@bc],ax
	lodsw
	mov	[@iy],ax
	lodsw
	mov	[@ix],ax
	lodsw
	mov	[@iff],al
	mov	[@r],ah
	lodsw
	mov	[word @f],ax
	lodsw
	mov	di,ax
	lodsb
	mov	[@im],al
	lodsb
	and	al,7
	mov	bx,PAL
	segss
	xlat
	mov	[@brd],al
	mov	ds,[cs:emudata]

	mov	ax,[di]
	mov	[@pc],ax
	inc	di
	inc	di
	mov	[@sp],di
	
	pop	ds
	clc
	ret
endp
;
proc	scrfsh
	push	ax bx cx ds es
	mov	ds,[cs:emudata]
	mov	ax,0B800h
	mov	es,ax
	mov	si,4000h
	mov	cx,1800h
@@1:	shl	si,1
	mov	di,[ss:si+VIDEO-8000h]
	shr	si,1
	movsb
	loop	@@1
	mov	cx,300h
	mov	bx,offset VIDEO+3000h
@@2:	shl	si,1
	mov	di,[ss:si+AVIDEO-0B000h]
	shr	si,1
	lodsb
	and	al,[@flash]
	segss
	xlat
	mov	[es:di],al
	mov	[es:di+40h],al
	mov	[es:di+80h],al
	mov	[es:di+0C0h],al
	mov	[es:di+100h],al
	mov	[es:di+140h],al
	mov	[es:di+180h],al
	mov	[es:di+1C0h],al
	loop	@@2

	mov	ax,[cs:emu128]
	add	ah,10h
	mov	ds,ax
	mov	si,8000h
	mov	cx,1800h
@@3:	shl	si,1
	mov	di,[ss:si+VIDEO]
	add	di,3000h
	shr	si,1
	movsb
	loop	@@3
	mov	cx,300h
	mov	bx,offset VIDEO+3000h
@@4:	shl	si,1
	mov	di,[ss:si+AVIDEO-3000h]
	shr	si,1
	lodsb
	and	al,[@flash]
	segcs
	xlat
	mov	[es:di+3000h],al
	mov	[es:di+3040h],al
	mov	[es:di+3080h],al
	mov	[es:di+30C0h],al
	mov	[es:di+3100h],al
	mov	[es:di+3140h],al
	mov	[es:di+3180h],al
	mov	[es:di+31C0h],al
	loop	@@4
	
	mov	dx,3DAh
	in	al,dx
	mov	dl,0C0h
	mov	al,31h
	out	dx,al
	mov	al,[@brd]
	out	dx,al

	pop	es ds cx bx ax
	ret
endp
;
proc	@debu
	mov	al,[ss:2Eh]
	add	al,'0'
	call	putchar
	mov	al,[ss:30h]
	add	al,'0'
	call	putchar
	
	call	putstr
	db	13,10,0
	ret
endp
;
proc	pagload
	call	pageadr
	mov	cx,4000h
	mov	ah,3Fh
	int	21h
	jc	@@3
	cmp	ax,cx
	jz	@@3
	stc
@@3:	ret
endp
;
proc	pageadr
	mov	dx,0C000h
	and	al,7
	jnz	@@1
@@2:	mov	ds,[cs:emudata]
@@0:	ret
;		
@@1:	mov	dh,40h
	cmp	al,5
	jz	@@2
	mov	dh,80h
	cmp	al,2
	jz	@@2
	mov	ds,[cs:emu128]
	mov	dh,80h
	cmp	al,1
	jz	@@0
	mov	dh,0C0h
	cmp	al,3
	jz	@@0
	mov	dx,[cs:emu128]
	add	dh,10h
	mov	ds,dx
	xor	dx,dx
	cmp	al,4
	jz	@@0
	mov	dh,40h
	cmp	al,6
	jz	@@0
	mov	dh,80h
	ret
endp
;


proc	nextarg
@@2:	mov	al,[cs:inbuf+si]
	inc	si
	cmp	al,13
	jz	@@1
	cmp	al,' '
	jnz	@@2
@@3:	mov	al,[cs:inbuf+si]
	inc	si
	cmp	al,13
	jz	@@1
	cmp	al,' '
	jz	@@3
	dec	si
@@1:	ret
endp
;
proc	findcmd
	push	di cx
	mov	di,offset cmds
@@7:	push	si
	mov	cx,di
	mov	ax,[word cs:di]
	and	ax,ax
	jz	@@5
	xor	ah,ah
	add	di,4
@@4:	mov	al,[cs:inbuf+si]
	inc	si
	cmp	al,13
	jz	@@5
	cmp	al,' '
	jz	@@4
@@9:	call	ucase
	cmp	al,[cs:di]
	jnz	@@6
	inc	di
	cmp	[byte cs:di],0
	jnz	@@8
	mov	ax,cx
@@5:	pop	cx cx di
	ret
;		
@@8:	mov	al,[cs:inbuf+si]
	inc	si
	cmp	al,13
	jz	@@6
	jmp	@@9
;		
@@6:	inc	di
	cmp	[byte cs:di],0
	jnz	@@6
	pop	si
	inc	di
	jmp	@@7
endp
;
proc	ucase
	cmp	al,'a'
	jb	@@1
	cmp	al,'z'
	ja	@@1
	sub	al,20h
@@1:	ret
endp
;
@h_cn	db	'   CONT[INUE]',13,10,10
	db	'Continue program',13,10,0
@h_qu	db	'      QUIT',13,10,10
	db	'Quit to MS-DOS',13,10,0
@h_hl	db	'  HELP [command]',13,10
	db	'or   ? [command]',13,10,10
	db	'Help about command',13,10,0
@h_cl	db	'      CLS',13,10,10
	db	'Clear setup window',13,10,0
@h_ds	db	'  DISK [TR-DISK] [file.trd]',13,10,10
	db	'Display filenames, assigned',13,10
	db	'to TR-DOS disks, or assign',13,10
	db	'file.trd to TR-DOS disk',13,10
	db	'TR-DISK is A,B,C or D',13,10,0
@h_ld	db	'   LOAD <file.sna>',13,10
	db	'or LOAD <file.z80>',13,10,10
	db	'Load snapshot file',13,10,0
@h_res	db	' RESE[T] [128 | 48 | DOS]',13,10
	db	'Restart Spectrum in new mode',13,10,10,0
@h_del	db	' DELA[Y] [rate]',13,10
	db	'Show or set delay rate 0-70',13,10,10,0
@h_pri	db	' PRIN[T] S[CREEN]',13,10
	db	'Print screen on EPSON',13,10,10,0
;	
cmds	dw	@cont,@h_cn
	db	'CONT',0
	dw	@quit,@h_qu
	db	'QUIT',0
	dw	@help,@h_hl
	db	'HELP',0
	dw	@help,@h_hl
	db	'?',0
	dw	@cls,@h_cl
	db	'CLS',0
	dw	@disk,@h_ds
	db	'DISK',0
	dw	@load,@h_ld
	db	'LOAD',0
	dw	@res,@h_res
	db	'RESE',0
	dw	@dela,@h_del
	db	'DELA',0
	dw	@prn,@h_pri
	db	'PRIN',0
	dw	@debu,@h_hl
	db	'DEBUG',0
	dw	0
;  cmdline 
cmdkeys	dw	@vgabios
	db	'VGABIOS',0
	dw	@covox
	db	'COVOX',0
	dw	@debug
	db	'DEBUG',0
	dw	@noadl
	db	'NOADLIB',0
	dw	@emr1
	db	'EMRON',0
	dw	@emr0
	db	'EMROFF',0
	dw	-1
hard	db	0
hard2	db	8
modes	db	0		; bit0 = disable 128K
cpu	db	'cpu1.bin',0
rom1	db	'roms.bin',0
;  SETUP 
rate	db	3
crtr7	db	0
crtr24	db	64

align	2
;     
serial	dw	3f8h
mini1	dw	300h,100h,380h,100h,60h,302h,401h,0ffffh
mini2	dw	300h,100h,380h,100h,60h,302h,0ffffh
mini3	dw	40bh,101h,0ffffh
; 
lptabs	db	lpt2-$-1
;	db	27,'K',0,1
	db	27,'*',5,0,1
lpt2	db	lpt3-$-1
	db	27,'3',24,13,10
lpt3	=	$
;   
seqtab	db	1,09h,04h,0,07h,0ffh
crtvga	db	2dh,1fh,24h,0ch,28h,8dh,0dh,00111110b,0,080h,0,1,VPAGE1 SHR 9,0,7Fh,0
	db	0c4h,0b9h,07fh,10h,1fh,0b4h,0e8h,0a3h,090h,0ffh
crtega	db	37h,1fh,29h,0fh,29h,0fh,06h,00010001b,0,0,0,0,0,0,0,0
	db	0e1h,35h,0bfh,10h,1fh,0e0h,0e2h,0a3h,0ffh
rgb	db	0,0,0,0,0,46,0,46,0,0,46,46,46,0,0,46,0,46,46,46,0,46,46,46
d_pal:	db	0,1,4,5,2,3,6,7,0,39h,3ch,3dh,3ah,3bh,3eh,3fh,04h
video2:	IRPC	B,08
	IRPC	P,01234567
	IRPC	I,01234567
	db	B*17+P*16+I
	ENDM
	ENDM
	ENDM
	IRPC	B,08
	IRPC	P,01234567
	IRPC	I,01234567
	db	B*17+I*16+P
	ENDM
	ENDM
	ENDM
;  AY-8910 
tbadl:	dw	500h,0BD20h
	dw	2022h,2122h,2222h,2324h,2424h,2524h
	dw	2821h,2921h,2A21h,2B24h,2C24h,2D24h
	dw	3021h,3121h,3221h,3324h,3424h,3524h
;
	dw	403Fh,413Fh,423Fh,433Fh,443Fh,453Fh
	dw	483Fh,493Fh,4A3Fh,4B3Fh,4C3Fh,4D3Fh
	dw	503Fh,513Fh,523Fh,533Fh,543Fh,553Fh
;
	dw	60F0h,61F0h,62F0h,63F0h,64F0h,65F0h
	dw	6800h,6900h,6A00h,6B00h,6C00h,6D00h
	dw	7000h,7100h,7200h,7300h,74F0h,7500h
;
	dw	80FFh,81FFh,82FFh,83FFh,84FFh,85FFh
	dw	8800h,8900h,8A00h,8B00h,8C00h,8D00h
	dw	9000h,9100h,9200h,9300h,94FFh,9500h
;
	dw	0E003h,0E103h,0E203h,0E301h,0E401h,0E501h
	dw	0E800h,0E900h,0EA00h,0EB01h,0EC01h,0ED01h
	dw	0F000h,0F100h,0F200h,0F301h,0F400h,0F501h
;
	dw	0C001h,0C101h,0C201h,0C301h,0C401h,0C501h,0C601h,0C701h,0C801h
	dw	0A000h,0A100h,0A200h,0A300h,0A400h,0A500h,0A600h,0A700h,0A800h
	dw	0B000h,0B100h,0B200h,0B300h,0B400h,0B500h,0B600h,0B700h,0B800h
	dw	0BD28h,0
;  common 
scanxlt	db	0,0,'1234567890-=',8,0
	db	'qwertyuiop[]',13,0,'as'
	db	'dfghjkl;''`',0,'\zxcv'
	db	'bnm,./',0,0,0,' ',0,0,0,0,0,0
	db	0,0,0,0,0,0,0,0,0,0,'-',0,0,0,'+',0
	db	0,0,0,0
scanxl2	db	0,0,'!@#$%^&*()_+',8,0
	db	'QWERTYUIOP{}',13,0,'AS'
	db	'DFGHJKL:"~',0,'|ZXCV'
	db	'BNM<>?',0,0,0,' ',0,0,0,0,0,0
	db	0,0,0,0,0,0,0,0,0,0,'-',0,0,0,'+',0
	db	0,0,0,0
rom	dw	rom1
go	dw	0; Ŀ
emucode	dw	?; 
;crt	dw	?
oldmode	db	?
@oscan	db	2
ldmode	db	0
dirspl	db	0
scanc	db	0
intcnt	db	0
oldcpos	db	0
kflg1	db	0
mod128	db	0
emudata	dw	?
goovl	dw	10h; Ŀ
stkseg	dw	?  ; 
sysseg	dw	?
emu128	dw	?
tapseg	dw	?
oi8	dw	0,0
oi9	dw	0,0
split	dw	0
cursor	dw	0
inbuf	db	32 dup (0)
sfile	db	'default.cfg',21 dup (0)
sfh	dw	0
io2pt	dw	0
curdel	db	0
	db	0
;  PM 
rgss	db	'AX',14,'BX',8,'CX',12,'DX',10,'SI',2,'DI',0,'BP',16,'SP',6
	db	0
;  Debugger 
country	db	12h dup (?)
casemap	dw	?,?
	db	0ah dup (?)
fnbuf	db	256 dup (?)
iobuf	db	256 dup (?)
io2buf	db	256 dup (?)
bufprn	db	8 dup (?)
segment	uss
group	DGROUP uss
endprg:
ends

;endprg	= $-@startup+10Fh

end


